      PROGRAM BALNINPT
C
C     $Revision: 1.6 
C   
C     $Date: 1993/12/23 19:00:55 
C
C     $Author: dlpark 
C
C
C
C             BALANCE INPUT
C
C
C
      INCLUDE 'balninpt.cb'
      INCLUDE 'one.cb'
      LOGICAL OLDADD, NOLD, EOLD, ACHAN
      CHARACTER*80 PLINE, NLINE, FLINE(100), FORMA, OFILE, TEMP2
      CHARACTER*15 FORMT1, FMT
      CHARACTER*14 VERSN
      CHARACTER*10 BLANK, NELT, NLT(7), SPACE, CDELT, CFINAL, CINTIAL,
     &             CINTI2, NPHAS
      CHARACTER*8 PNAME1
      CHARACTER*2 BANS,NLTI,PELT2(30,7)
      CHARACTER*1 ANS,CHINT,CERR
      INTEGER FLIN, OIFORM(30), FORM
      DOUBLE PRECISION COEFF, PCOEFF2(30,7)
      INTEGER IBALN, ICHEK, IDIFF, IERR, IND, IOVW, IPHAS, IQZ, ISE,
     &        ISEC, ITIME, IWISH, MXFLIN, ISCR, I, IANS, IOVER, IOPT,
     &        LENGTH, IXCES, IFLNT2, IOUT, IHE, J, IFLAG2, IJ, JK, KI,
     &        LENGT, IEP, JSIZ, IOIFORM, JDIFL, INTE, IDE, INTP, IFORM,
     &        IJJ, IQQ, IIK, ICH, IOFORM, IQU, IQR, ITYP0, NOELT,
     &        NOPHAS, JJ, KK, II, IJK, IS, IF, NUMEL, INTI, IFLAG,
     &        LENCHR
      LOGICAL OPENED, BATCH
      CHARACTER*80 MINDB, QUERY
      CHARACTER*10 STAT
      EXTERNAL OPENIT, RANS, DESC, MODN, LENCHR, UPCS, XCES, HELP, BALN,
     &         CHEK, NLTS, SOL, RNDF, INPT
      INTRINSIC CHAR, MOD, ABS, LEN, ICHAR
      DATA BLANK/'          '/
C
C     CERR=BELL TONE
      CERR=CHAR(7)
C********************************************************************
C             EXPLAINATION OF SOME FLAGS
C
C          IADD   IF = 1 , YOU'RE ADDING ELEMENT AND/OR PHASE
C          IANS   IF = 1 , USER ANSWERED YES
C       ICHANFORM IF = 1 , YOU'VE CHANGED SOLUTION FORMAT
C          ICHEK  IF = 1 , LINE IS OK
C          IDE    IF = 1 , YOU ARE DELETING ELEMENT AND PHASE
C          IFORM  IF = 1 , USER IS ONLY ADDING ELEMENT
C          IHE    IF = 1 , SOLUTION FORMAT IS INCORRECT
C         IOIFORM IF = 1 , FORMAT IS MIXING
C     ->   IOLD   IF = 1 , EDITING FILE , =0 INPUTING FILE  <-
C          IOVER  IF = 1 , USER WISHES TO OVERWRITE
C          IOVW   IF = 1 , YOU ALREADY INPUTED AN EXISTING FILE
C          IPHAS  IF = 1 , PHASE INPUT ALREADY INTIALIZED
C          IQUIT  IF = 1 , USER WISHES TO ABORT PROGRAM
C          NRUN   IF = 1 , PRINT OUT ERROR MESSAGES FROM BALANCE
C  IQ(some char.) IF = 1 , YOU ASKED FOR HELP
C          ITIME  IF = 0 , YOU'RE PRINTING FILE 1ST TIME
C          IWISH  IF = 1 , USER WISHES TO RUN BALANCE
C********************************************************************
C      AND SOME VARIBLES...
C
C          A      LINE YOU ARE POINTING AT
C          CHECK  INPUT FILE EXISTS
C          CHECK2 OUTPUT FILE EXISTS
C          FILE   INPUT FILE
C          IBALN  NUMBER OF BLANK LINES IN INPUT FILE
C          K      LBLOK POINTER
C          LBLOK  STORES LINE NUMBERS OF BLANK LINES
C          LIN    NUMBER OF LINES IN INPUT FILE
C          MXFLIN MAXIMUM NUMBER OF LINES IN PHASE DATA FILE =100
C          MXLIN  MAXIMUM NUMBER OF LINES IN FILE =100
C          NBLOK  NUMBER OF DATA BLOCKS IN FILE
C          NEFLE  OUTPUT FILE
C          NMOD   NUMBER OF MODELS USER HAS
C          NOLINE NUMBER OF LINES IN PREVIOUS MODEL
C          OLINE  STORES LINES OF THE PREVIOUS MODEL
C          ISTDI  STANDARD INPUT (UNIT 5 ON DG)
C          ISTDO  STANDARD OUTPUT (UNIT 6 ON DG)
C          RUNIT  LOGICAL UNIT 7 IS READ
C          WUNIT  LOGICAL UNIT 8 IS WRITE
C          RWUNIT LOGICAL UNIT 9 IS OPTIONAL
C********************************************************************
C The following are limits on the values of important varibles
C in BALN INPT.  Each limit lists what the limit is of, what the
C limit is, what varibles are dimensioned for that limit, and,
C optionally, what varible holds values up to that limit.
C                  LIMIT        VARIBLE(S)    REFERENCE
C Lines in a file   100    LINE(100)        LIN,MXLIN
C
C Letters in a line  80    LINE(100),PLINE,
C                          NLINE,OLINE(40)
C
C Letters in               FILE,NEFLE,
C  file names        80    DATA,OFILE
C
C Name of
Cdata file  BALNINPT.DAT   DATA
C
C Elements in phase  7     NLT(7),PELT2(30,7),    INT
C                            PCOEFF(30,7)
C
C Elements printed  30     ACELE(30)      ILEN
C for element help
C
C Models in a file  15     LBLOK(0:40)    NBLOK,K,NMOD
C
C Lines in
C  phase data file 100     FLINE(100)     FLIN,MXFLIN
C
C Lines in a model   40    OLINE(40)      LBLOK(0:30)
C
C Lines of
C elements or phases 30    PELT2(30,7),   LBLOK(0:40),NOELTS,
C                          PCOEFF2(30,7),   NOPHAS
C                          OIFORM(30)
C*********************************************************************
      QUERY = 
     &       '@(#)BALNINPT - Mass balance model with isotope evolutions'
      QUERY = '@(#)BALNINPT - USGS WRIR 82-14, Parkhurst, Plummer, & Tho
     &rstenson'
      QUERY = '@(#)BALNINPT - Contact: h2osoft@usgs.gov'
      QUERY = '@(#)BALNINPT - Version: 1.9x 1994/11/14'
C     Set RCS ident string
      QUERY =
     & '$Id: balninpt.f,v 1.9 1994/11/14 16:11:55 dlpark Exp '
      VERSN = QUERY(19:32)
      IBALN=0
      ICHEK=0
      IDIFF=0
      IERR=0
      IND=0
      IOVW=0
      IPHAS=0
      IQUIT=0
      IQZ=0
      ISE=0
      ISEC=0
      ITIME=0
      IWISH=0
      MXFLIN=100
      MXLIN=100
      NMOD=0
      FORM = 0
      IDE = 0
C          UNIT TO READ FROM TERMINAL
      ISTDI=5
C          UNIT TO WRITE TO THE TERMINAL
      ISTDO=6
C          UNIT TO READ FILES FROM
      RUNIT=7
C          UNIT TO WRITE FILES TO
      WUNIT=8
C          UNIT TO READ DATA FILE FROM
      RWUNIT=9
C          UNIT TO READ NAME OF DATA FILE FROM
      ISCR=10
C
C     READ FILE NAMES FROM STANDARD INPUT
C     IF BATCH.EQ.TRUE, QUERIES ARE DISABLED.
C
      INQUIRE (FILE='FNAMES.FIL', EXIST=BATCH)
      IF (BATCH) THEN
         OPEN (UNIT=ISCR, FILE='FNAMES.FIL', STATUS='OLD')
         OPENED = .TRUE.
      ELSE
         OPENED = .FALSE.
      ENDIF
C
C                               OPEN MINERALS DATA FILE
C
      STAT='OLD'
      QUERY='Name of file with mineral data? '
      MINDB='balninpt.dat'
      CALL OPENIT(QUERY, MINDB, RWUNIT, STAT, BATCH, ISCR)
      IF (OPENED) CLOSE(UNIT=ISCR)
C
C          READ NAME OF DATA FILE
C
      DO 64 I=0,40
   64 LBLOK(I)=0
C
C       READ MINERALS
C
      I=1
   35 READ(RWUNIT,501,END=36) FLINE(I)
      I=I+1
      IF (I.LE.MXFLIN) GO TO 35
      WRITE(ISTDO,51) MXFLIN,CERR
   51 FORMAT (' ERROR! Phase data file has more than ',I3,' lines!',A)
      STOP 'PROGRAM ABORTED'
C
   36 FLIN=I-1
      CLOSE (UNIT=RWUNIT)
      IANS=0
      IOVER=0
      WRITE(ISTDO,100) VERSN
  100 FORMAT (////,21X,'*************',/,21X,'BALANCE INPUT',/,21X,
     &        '*************',/,14X,'(Version:  ',A,')',///,
     &        5X,'If you do not understand something, type a "?"',//,
     &        14X,'To leave program, type a "*"',////)
      WRITE(ISTDO,71)
   71 FORMAT (' Do you want to see a description of the program?')
      CALL RANS(IANS)
      IF (IANS.NE.0) CALL DESC
      IF (IQUIT.EQ.1) STOP
   11 WRITE(ISTDO,103)
  103 FORMAT (' Model file name?')
      READ(ISTDI,110) NEFLE
  110 FORMAT (A80)
      IF (NEFLE.EQ.'*') STOP
      IF (NEFLE.NE.'?') GO TO 15
   27 WRITE(ISTDO,101)
  101 FORMAT (//,6X,
     &     'The model file will contain the ground water model which',/,
     &     ' is used to calculate the mass tranfer.',//)
      GO TO 11
C
   15 INQUIRE (FILE=NEFLE,EXIST=CHECK2,ERR=27)
      IF (IOVW.EQ.0) WRITE(ISTDO,120)
  120 FORMAT (
     &     ' Enter name of existing model file. (If none hit <RETURN>)')
      IF (IOVW.EQ.0) READ(ISTDI,110) FILE
      IF (FILE.EQ.'*') STOP
      IF (FILE.NE.'?') GO TO 254
   14 WRITE(ISTDO,102)
  102 FORMAT (//,6X,
     &    'The existing model file is a list of ground water models,',/,
     &    ' already in correct format, which you wish to alter.',//)
      GO TO 15
C
  254 IF (CHECK2) GO TO 20
      IF (FILE.NE.BLANK) GO TO 49
   40 NMOD=1
      NBLOK=1
      IOLD=0
      A=1
      K=1
      GO TO 207
C
   30 OPEN (RUNIT,FILE=NEFLE)
      IF (FILE.NE.NEFLE) CLOSE (RUNIT,STATUS='DELETE')
   49 INQUIRE (FILE=FILE,EXIST=CHECK,ERR=14)
      IF (CHECK) GO TO 245
      WRITE(ISTDO,622) CERR
  622 FORMAT (' ERROR! That file does not exist!',A)
      IF (NMOD.EQ.0) GO TO 15
      NMOD=NMOD-1
      CALL MODN(IOPT)
      IF (IQUIT.EQ.1) GO TO 60
      GO TO (49,142,74) IOPT+1
C
C        HE INPUTED AN EXISTING FILE
C
   20 WRITE(ISTDO,115) NEFLE
  115 FORMAT (' Do you wish to overwrite ',/,1X,A80)
      CALL RANS(IOVER)
      IF (IQUIT.EQ.1) GO TO 60
      IF (IOVER.EQ.0) IOVW=1
      IF (FILE.NE.BLANK.OR.IOVER.NE.1) GO TO (11,30,52,52) IOVER+1
C                THIS IS THE                 /   |   \    \
C              STANDARD FORM OF   ->       NO!  YES!   \   WHAT?
C               ANSWER "GOTO'S"                   ERROR INPUT!
C
      OPEN (RWUNIT,FILE=NEFLE)
      CLOSE (RWUNIT,STATUS='DELETE')
      GO TO 40
C
   52 LENGTH = LENCHR(NEFLE)
      CALL UPCS(NEFLE(1:LENGTH))
      WRITE(ISTDO,54) NEFLE(1:LENGTH)
   54 FORMAT (//,6X,
     &'The file you wish to write to, ',A,', already exists.',/,
     &' Do you want to overwrite what is in the file so you can use it f
     &or input?',//)
      GO TO 20
C
  245 CLOSE (UNIT=RUNIT)
      OPEN (RUNIT,FILE=FILE)
      IXCES=0
      I=1
      IF (NMOD.NE.0) I=LBLOK(K-2)+1
   32 IF (I.GE.MXLIN+2) GO TO 70
      READ(RUNIT,501,END=31) LINE(I)
  501 FORMAT (A80)
      IF (I.EQ.MXLIN+1) GO TO 70
      I=I+1
      GO TO 32
C          SET EXCESS FLAG IF I>MXLIN(=100)
   70 IXCES=1
   31 IOLD=1
      LIN=I-1
      IF (FILE.EQ.NEFLE.AND.IOVER.EQ.1) CLOSE (RUNIT,STATUS='DELETE')
      IF (LINE(LIN).EQ.BLANK.OR.IXCES.EQ.1) GO TO 161
      LIN=LIN+1
      LINE(LIN)=BLANK
  161 IBALN=0
      DO 160 I=1,LIN
      IF (LINE(I).NE.BLANK) GO TO 160
      IBALN=IBALN+1
      LBLOK(IBALN)=I
  160 CONTINUE
      IFLEN=1
      IF (IBALN.GT.2) IFLEN=0
      IF (NMOD.GT.IBALN/2.AND.IXCES.EQ.1) GO TO 67
      IF (IXCES.EQ.0) GO TO 34
      IBALN=IBALN-MOD(IBALN,2)
      WRITE(ISTDO,68) IBALN/2+1
   68 FORMAT (' WARNING!  Trailing model #',I2,' is being dropped.')
      LIN=LBLOK(IBALN)
   34 CONTINUE
      IF (MOD(IBALN,2).EQ.0) GO TO 61
      WRITE(ISTDO,62)
   62 FORMAT (/,' Your input file is not in correct format, and it is',/
     1,' beyond the capabilities of this program to correct it.',//)
      GO TO 15
C          CALL EXCESS
   67 TEMP2=TEMP
      TEMP=FILE
      FILE=TEMP2
      IFLNT2=IFLEN
      IFLEN=IFLENT
      IFLENT=IFLNT2
      NBLOK=(IBALN+2-MOD(IBALN,2))/2
      IF (NMOD.EQ.0) NMOD=1
      CALL XCES(0,0,IOUT)
      IF (IQUIT.EQ.1) GO TO 60
      I=LIN+1
      IXCES=0
      IF (IOUT.EQ.2) GO TO 31
C
C        INTIALIZE FOR BLOCK LOOP
C
   61 TEMP=FILE
      NMOD=IBALN/2
      IF (NMOD.EQ.0) NMOD=1
      NOLINE=LBLOK(2*NMOD)-LBLOK(2*NMOD-2)
      LOBLOK=LBLOK(2*NMOD-1)-LBLOK(2*NMOD-2)
      DO 75 I=LBLOK(2*NMOD-2)+1,LBLOK(2*NMOD)
   75 OLINE(I-LBLOK(2*NMOD-2))=LINE(I)
      IEDIT=0
      IADD=0
      IHE=0
      K=2*NMOD
  142 CONTINUE
      ICHANFORM=0
      J=1
      IF (2*NMOD.LT.K) K=2
C
C          WRITE OUT BLOCK
C
      WRITE(ISTDO,63) K/2
   63 FORMAT (1X,20('*'),' Model #',I2,' ',20('*'))
      DO 118 I=LBLOK(K-2)+1,LBLOK(K)-1
      IF (I-LBLOK(K-2).NE.22*J-1) GO TO 244
      IFLAG2=0
      WRITE(ISTDO,626)
  626 FORMAT (' --Hit RETURN to see next page--')
      READ(ISTDI,628) ANS
  628 FORMAT (A)
      IF (ANS.EQ.'*'.AND.ITIME.EQ.0) STOP 'PROGRAM ABORTED'
      IF (ANS.NE.'*') GO TO (108,201) IFLAG2+1
      IQUIT=1
      GO TO 60

  108 J=J+1
  244 CONTINUE
      WRITE(ISTDO,601) I, LINE(I)
  601 FORMAT (1X,I3,':  ',A72)
  118 CONTINUE
   93 CONTINUE
      IF (J*22-I+LBLOK(K-2).LT.6) THEN
       IFLAG2=1
       WRITE(ISTDO,626)
       READ(ISTDI,628) ANS
       IF (ANS.EQ.'*'.AND.ITIME.EQ.0) STOP 'PROGRAM ABORTED'
       IF (ANS.NE.'*') GO TO (199,201) IFLAG2+1
       IQUIT=1
       GO TO 60
  199  J=J+1
       WRITE(ISTDO,601) I, LINE(I)
       GOTO 93
      ENDIF
C
C            CHECK FILE FOR ERRORS
C
  201 CONTINUE
      IADD=0
C
C         CHECK IF ALL ELEMENTS ARE TAKEN CARE OF IN THE PHASES
C
      DO 149 IJ=LBLOK(K-2)+2,LBLOK(K-1)-1
      DO 150 JK=1,LBLOK(K)-LBLOK(K-1)-1
      PLINE=LINE(JK+LBLOK(K-1))
      READ(PLINE,524,ERR=28) PNAME1,(PELT2(JK,KI),PCOEFF2(JK,KI)
     *                                                  ,KI=1,7)
  524 FORMAT (A8,2X,7(A2,F8.3))
      DO 151 KI=1,7
      IF (LINE(IJ)(1:2).EQ.PELT2(JK,KI)) GO TO 149
  151 CONTINUE
  150 CONTINUE
      WRITE(ISTDO,525) LINE (IJ)(1:2)
  525 FORMAT (' WARNING! ',A2,
     &        ' is not contained in any of the phases you have chosen.')
  149 CONTINUE
C
C           CHECK IF ALL PHASES CONTAIN SOME USED ELEMENT
C
      DO 16 JK=1,LBLOK(K)-LBLOK(K-1)-1
      PLINE=LINE(JK+LBLOK(K-1))
      READ(PLINE,524,ERR=28) PNAME1,(PELT2(JK,KI),PCOEFF2(JK,KI)
     *                                                  ,KI=1,7)
      DO 17 IJ=LBLOK(K-2)+2,LBLOK(K-1)-1
      DO 18 KI=1,7
   18 IF (LINE(IJ)(1:2).EQ.PELT2(JK,KI)) GO TO 16
   17 CONTINUE
      WRITE(ISTDO,19) PNAME1
   19 FORMAT (' WARNING! ',A8,
     &        ' does not contain any of your inputted elements.')
   16 CONTINUE
C
C           CHECK IF ALL SOLUTION DATA IS IN THE SAME FORMAT
C
      DO 238 I=LBLOK(K-2)+2,LBLOK(K-1)-1
      LENGT = LENCHR(LINE(I))
      DO 239 IEP=0,5
      DO 240 JSIZ=1,3
      IF (ABS(LENGT-JSIZ*10).LE.IEP) GO TO 241
  240 CONTINUE
  239 CONTINUE
  241 OIFORM(I-LBLOK(K-2)-1)=JSIZ
      IF ((I.NE.LBLOK(K-2)+2).AND.(OIFORM(I-LBLOK(K-2)-1).NE.
     *          OIFORM(I-LBLOK(K-2)-2))) GO TO 243
  238 CONTINUE
  255 CONTINUE
      ISE=0
C
C     CHECK IF #ELEMENTS MATCHES #PHASES
C
      IOIFORM=0
      JDIFL=0
      IF (OIFORM(1).EQ.3) IOIFORM=1
      IF (2*LBLOK(K-1)-LBLOK(K)-LBLOK(K-2)-IOIFORM-1) 121,121,105
C                                                     /    |   \
C        MORE ELEMENTS THAN PHASES               PH>ELE  EQUAL  ELE>PH
C
  105 IADD=1
C                     IDIFF=DIFFERENCE BETWEEN #ELE AND #PHASES
      IF (JDIFL.EQ.0) IDIFF=2*LBLOK(K-1)-LBLOK(K)-LBLOK(K-2)-IOIFORM-1
      JDIFL=1
      WRITE(ISTDO,502) IDIFF
  502 FORMAT (6X,
     &   'The number of elements in your model exceeds the number',/,
     &   ' of phases by ',I2,'.  You must either 1.Delete an element',/,
     &   ' or 2.Add a phase.  Input your choice.')
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.NE.'2'.AND.PLINE.NE.'ADD'.AND.PLINE.NE.'PHASE') GO TO 11
     *2
      DO 113 I=LIN,LBLOK(K),-1
  113 LINE(I+1)=LINE(I)
      LIN=LIN+1
      DO 114 I=K,NMOD*2
  114 LBLOK(I)=LBLOK(I)+1
      A=LBLOK(K)-1
      OLDADD=.FALSE.
      GO TO 222
C
  112 IF (PLINE.NE.'1'.AND.PLINE.NE.'DELETE'.AND.PLINE.NE.'ELEMENT') GO
     1TO 105
C
C        PRINT ELEMENTS
C
  116 DO 119 I=LBLOK(K-2)+2,LBLOK(K-1)-1
  119 WRITE(ISTDO,601) I,LINE(I)
      WRITE(ISTDO,503)
  503 FORMAT (//,' Input line number of element to be deleted.')
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      READ(PLINE,517,ERR=116) INTE
  517 FORMAT (I3)
      IF (INTE.GE.LBLOK(K-2)+2.AND.INTE.LE.LBLOK(K-1)-1) GO TO 122
      WRITE(ISTDO,504) INTE, CERR
  504 FORMAT (' ERROR! ',I3,' is not a line number in this model!',A)
      GO TO 116
C
  122 DO 123 J=INTE,LIN-1
  123 LINE(J)=LINE(J+1)
      LIN=LIN-1
      DO 124 J=K-1,NMOD*2
  124 LBLOK(J)=LBLOK(J)-1
      IF (IDE.EQ.1) GO TO 248
      IADD=0
      IDIFF=IDIFF-1
      IF (IDIFF.LE.0) GO TO 201
      GO TO 105
C
C
  246 IF (PLINE.NE.'2'.AND.PLINE.NE.'DELETE'.AND.PLINE.NE.'PHASE') 
     &    GO TO 255
C
C        PRINT PHASES
C
  250 DO 247 I=LBLOK(K-1)+1,LBLOK(K)-1
  247 WRITE(ISTDO,601) I, LINE(I)
      WRITE(ISTDO,631)
  631 FORMAT (//,' Input line number of phase to be deleted.')
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      READ(PLINE,517,ERR=250) INTP
      IF (INTP.GE.LBLOK(K-1)+1.AND.INTP.LE.LBLOK(K)-1) GO TO 248
      WRITE(ISTDO,44) INTP, CERR
   44 FORMAT (' ERROR! ',I3,' is not a line number in this model!',A)
      GO TO 250
C
  248 IF (IDE.EQ.1) INTP=INTP-1
      DO 252 J=INTP,LIN-1
  252 LINE(J)=LINE(J+1)
      LIN=LIN-1
      DO 253 I=K,NMOD*2
  253 LBLOK(I)=LBLOK(I)-1
      IF (IDE.EQ.1) GO TO 201
      IFORM=0
      IADD=0
      IDIFF=IDIFF-1
      IF (IDIFF.LE.0) GO TO 201
      GO TO 89
C
  243 ISE=1
      IF (ISEC.GE.1) WRITE(ISTDO,162) CERR
  162 FORMAT (' ERROR!',A)
      WRITE(ISTDO,615)
  615 FORMAT (
     &    ' You have not changed all solution data to the same format.')
C            BEGIN EDITTING
  121 IDE=0
      ISEC=0
      IDIFF=0
      WRITE(ISTDO,616)
  616 FORMAT (1X,43('*'),/,
     &    ' *** Enter LINE NUMBER you wish to edit. ***',/,1X,43('*'),/,
     &    6X,'Alternatives include :',/,
     &' (Push "Q" to leave BALN INPT, "N" to see next model, "M"# to see
     & model no. #)'/,
     &' ("A" to add a line, "D" to delete a line, "P" to reprint model)'
     &,/,' ("R" to run BALANCE, "?" for help with commands, "*" to abort
     & program)')
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.EQ.'Q' .OR. PLINE.EQ.'q' .OR. PLINE.EQ.'P' .OR.
     &    PLINE.EQ.'p' .OR. PLINE.EQ.'A' .OR. PLINE.EQ.'a' .OR.
     &    PLINE.EQ.'D' .OR. PLINE.EQ.'d' .OR. PLINE.EQ.'R' .OR.
     &    PLINE.EQ.'r' .OR. PLINE.EQ.'N' .OR. PLINE.EQ.'n' .OR.
     &    PLINE.EQ.'M' .OR. PLINE.EQ.'m') GOTO 251
C
C            READ LINE NUMBER TO EDIT
C
  230 READ(PLINE,603,ERR=43) A
  603 FORMAT (I3)
C
C            ERRORS
C
      IF (A.GE.LBLOK(K-2)+1.AND.A.LE.LBLOK(K)) GO TO 211
      IF (A.EQ.0) GO TO 43
      WRITE(ISTDO,606)
  606 FORMAT (' Type a number in this model, please.')
      GO TO 201
C
   43 CALL HELP(PLINE)
      IF (IQUIT.EQ.1) GO TO 60
      GO TO 201
C
   28 WRITE(ISTDO,50) JK+LBLOK(K-1),PLINE
   50 FORMAT (' ERROR while reading ',I4,': ',A80,/,
     &        ' You may have given BALN INPT an improper file.')
      STOP
C
  211 CONTINUE
C     IF CORRECT LINE NUMBER, WRITE LINE
      IF (A.NE.LBLOK(K-1).AND.A.NE.LBLOK(K)) GO TO 229
      WRITE(ISTDO,624) CERR
  624 FORMAT (' ERROR! That line is blank!',A)
      GO TO 201
C
C
C        QUITING FILE:GO TO NEXT BLOCK
C
  251 IF (PLINE(1:1).NE.'Q'.AND.PLINE(1:1).NE.'q'.AND.PLINE(1:1).NE.'N'.
     *AND.PLINE(1:1).NE.'n'.AND.PLINE(1:1).NE.'M'.AND.PLINE(1:1).NE.'m')
     * GO TO 24
      ISEC=ISEC+1
      IF (ISE.EQ.1) GO TO 243
      ISEC=0
      DO 1159 I=LBLOK(K-2)+1,LBLOK(K)
 1159 OLINE(I-LBLOK(K-2))=LINE(I)
      NOLINE=LBLOK(K)-LBLOK(K-2)
      LOBLOK=LBLOK(K-1)-LBLOK(K-2)
      IF (PLINE(1:1).EQ.'M'.OR.PLINE(1:1).EQ.'m') GO TO 72
      K=K+2
      IF (PLINE.EQ.'Q'.OR.PLINE.EQ.'q') GO TO 45
      GO TO 142
C      LIST MODELS
   72 IF (PLINE(2:2).NE.'?') GOTO 86
      WRITE(ISTDO,22)
      DO 87 I=1,NMOD
   87 WRITE(ISTDO,88) I,LBLOK(2*I-2)+1,LINE(LBLOK(2*I-2)+1)
   88 FORMAT (' Model ',I2,', Line ',I3,' :  ',A80)
      WRITE(ISTDO,22)
      GO TO 201
C          GO TO MODEL #IJ
   86 PLINE(1:1)=' '
      IF (PLINE(2:2).EQ.' ') PLINE(2:2)='0'
      READ(PLINE,'(I2)',ERR=73) IJ
      IF (IJ.EQ.0) IJ=1
      IF (IJ.LT.0) GO TO 73
      IJJ=K
      K=IJ*2
      IF (IJ.LE.NMOD) GO TO 142
      K=IJJ
      IF (NMOD.EQ.1) WRITE(ISTDO,39) CERR
   39 FORMAT (' ERROR!  No such model!  There is only one model.',A,/)
      IF (NMOD.NE.1) WRITE(ISTDO,23) NMOD,CERR
   23 FORMAT (' ERROR!  No such model!  There are only ',I2,' models.',A
     &        ,/)
C      EXPLAIN MODEL# COMMAND
   73 PLINE(1:2)='?M'
      GO TO 43
C
C        RUNNING MODEL
C
   24 IF (PLINE(1:1).NE.'R'.AND.PLINE(1:1).NE.'r') GO TO 242
      OPEN (WUNIT,FILE='TEM.BAL',STATUS='UNKNOWN')
      DO 25 I=LBLOK(K-2)+1,LBLOK(K)
      WRITE(WUNIT,26) LINE(I)
   26 FORMAT (A80)
   25 CONTINUE
      CLOSE (WUNIT)
      OPEN (RUNIT,FILE='TEM.BAL')
      NRUN=1
      CALL BALN
      NRUN=0
      CLOSE (RUNIT,STATUS='DELETE')
      GO TO 121
C
C        PRINTING BLOCK
C
  242 IF (PLINE(1:1).NE.'P'.AND.PLINE(1:1).NE.'p') GO TO 205
      ITIME=1
      GO TO 142
C
C            ADDING A LINE
C
  205 IF (PLINE(1:1).NE.'A'.AND.PLINE(1:1).NE.'a') GO TO 144
      IEDIT=0
      IADD=1
      WRITE(ISTDO,249)
  249 FORMAT(/,' Input an 1.Element or a 2.Phase? Input choice.')
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.NE.'1'.AND.PLINE.NE.'ELEMENT') GO TO 233
      IF (LBLOK(K-1)-LBLOK(K-2)-2.LT.30) GO TO 89
      WRITE(ISTDO,90) CERR
   90 FORMAT (' ERROR! You cannot have more than thirty elements!',A)
      GO TO 201
C          MAKE ROOM FOR NEW ELEMENT
   89 IFORM=1
      JDIFL=1
      IEDIT=0
      IADD=1
      DO 234 I=LIN,LBLOK(K-1),-1
  234 LINE(I+1)=LINE(I)
      A=LBLOK(K-1)
      LIN=LIN+1
      DO 237 I=K-1,NMOD*2
      LBLOK(I)=LBLOK(I)+1
  237 CONTINUE
      GO TO 210
C
  233 CONTINUE
      DO 235 I=LIN,LBLOK(K),-1
  235 LINE(I+1)=LINE(I)
      A=LBLOK(K)
      LIN=LIN+1
      DO 236 I=K,NMOD*2
      LBLOK(I)=LBLOK(I)+1
  236 CONTINUE
      IPHAS=1
      GO TO 208
C
C          DELETING A LINE
C
  144 IF (PLINE(1:1).NE.'D'.AND.PLINE(1:1).NE.'d') GO TO 230
      WRITE(ISTDO,79)
  79  FORMAT(//,' Delete 1. an element or 2. a phase? Input choice')
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.EQ.'1'.OR.PLINE.EQ.'ELEMENT') GOTO 116
      GOTO 246
C
C     WRITE LINE TO BE EDITED
C
  229 WRITE(ISTDO,601) A, LINE(A)
      IF (A.NE.LBLOK(K-2)+1) GO TO 206
C
C           STATEMENT WHERE INPUT DATA
C                    COMES IN
C
  207 CONTINUE
      IF (IOLD.EQ.0) WRITE(ISTDO,63) (K+1)/2
      IF (IOLD.EQ.0) WRITE(ISTDO,22)
      IF (IOLD.EQ.1) WRITE(ISTDO,607) LINE(A)
  607 FORMAT (/,1X,A80)
   58 WRITE(ISTDO,604)
  604 FORMAT (' Input title.')
      IF (IOLD.EQ.1) WRITE(ISTDO,613)
  613 FORMAT (' (Push <RETURN> to keep old one.)')
      READ(ISTDI,501) NLINE
      IF (NLINE.EQ.'*') IQUIT=1
      IF (NLINE.EQ.'*') GO TO 60
      IF (NLINE.EQ.BLANK.AND.IOLD.EQ.1) GO TO 201
      CALL CHEK(NLINE,ICHEK)
C
C        MAKE SURE TITLE IS OK
C
      IF (ICHEK.EQ.0) GO TO (58,207) IOLD+1
      LINE(A)=NLINE
      GO TO (210,201) IOLD+1
C
  206 CONTINUE
      IF (A.GT.LBLOK(K-1)) GO TO 208
  210 CONTINUE
C
C        SOLUTION DATA
C
C     EOLD=.TRUE. PRINT OLD VAULES, .FALSE. DON'T PRINT
      EOLD=((IOLD.EQ.1.AND.IADD.EQ.0).OR.IEDIT.EQ.1)
      IF (.NOT.(.NOT.EOLD.AND.IADD.EQ.0.AND.IERR.EQ.0.AND.IQZ.EQ.0))
     *    GO TO 91
      IF (A-LBLOK(K-1)-2.LT.30) GO TO 92
      WRITE(ISTDO,90) CERR
      GO TO 208
C          START ON NEXT LINE
   92 A=A+1
   91 IOUT=1
      IF (A.GT.MXLIN) CALL XCES(0,0,IOUT)
      IF (IQUIT.EQ.1) GO TO 60
      IF (IOUT.EQ.0) GO TO 142
      IF (IOLD.EQ.0.AND.(A.EQ.LBLOK(K-1)+2.OR.IEDIT.EQ.1)) GO TO 66
      IF (IOLD.EQ.1) GO TO 66
      GO TO 65
C
   66 IF (IQZ.EQ.0) CALL NLTS(IQQ,1)
   65 IQZ=0
      IQQ=0
      IF (.NOT.EOLD.AND.IADD.EQ.0) WRITE(ISTDO,614)
  614 FORMAT (/,' Push <RETURN> when done inputting elements.')
      IF (EOLD) WRITE(ISTDO,608) LINE(A)(1:2)
  608 FORMAT (/,' Old element : ',A2)
      IF (.NOT.EOLD) WRITE(ISTDO,22)
      WRITE(ISTDO,605)
  605 FORMAT (' Input element.')
      IF (EOLD) WRITE(ISTDO,613)
      READ(ISTDI,130) NELT
  130 FORMAT (A10)
      IF (NELT.EQ.'*') IQUIT=1
      IF (NELT.EQ.'*') GO TO 60
      IF (NELT.EQ.'?') CALL NLTS(IQZ,0)
      IF (IQZ.EQ.1) GO TO 210
      IF (NELT.NE.BLANK) GO TO 221
      IF (EOLD) GO TO 139
      IF (A.GT.LBLOK(K-1)+2) GO TO 140
C
C          ERRORS WITH INPUT DATA
C
      WRITE(ISTDO,515) CERR
  515 FORMAT (' ERROR! You must input at least one element!',A,/)
      IERR=1
      GO TO 210
C
  140 IF (A.GT.LBLOK(K-1)+3.OR.FORM.NE.3) GO TO 208
      WRITE(ISTDO,516) CERR
  516 FORMAT (' ERROR! You must have at least two elements with a mixing
     * solution!',A,/)
      IERR=1
      GO TO 210
C
  139 IF (IADD.EQ.1) GO TO 210
      NELT=LINE(A)(1:2)
      GO TO 209
C               OTHER ERRORS
  221 CONTINUE
      IF (NELT(3:LEN(NELT)).EQ.BLANK) GO TO 209
      WRITE(ISTDO,609) CERR
  609 FORMAT (
     &' ERROR! Use standard abbreviations when inputting elements.',A,/)
      IERR=1
      GO TO 210
C
  209 DO 155 IIK=1,2
      ICH=ICHAR(NELT(IIK:IIK))
      IF (ICH.GE.97.AND.ICH.LE.121) NELT(IIK:IIK)=CHAR(ICH-32)
  155 CONTINUE
      IF (NELT(1:1).NE.' ') GO TO 231
      NELT(1:1)=NELT(2:2)
      NELT(2:2)=' '
  231 IERR=0
C
C          CHECK IF FORMAT HAS ALREADY BEEN INPUTED
C
      ACHAN=.NOT.(A.GT.LBLOK(K-1)+2.AND.ICHANFORM.EQ.0)
      IF ((IOLD.EQ.0.AND.IEDIT.EQ.0.AND.ACHAN)
     *     .OR.(IOLD.EQ.1.AND.IADD.EQ.1)) GO TO 217
      IF (IOLD.EQ.0.AND.(.NOT.ACHAN).AND.IEDIT.EQ.0) GO TO 216
C
C          FIND FORMAT OF OLD LINE
C
      LENGT = LENCHR(LINE(A))
      DO 212 IEP=0,5
      DO 213 JSIZ=1,3
      IF (ABS(LENGT-JSIZ*10).LE.IEP) GO TO 214
  213 CONTINUE
  212 CONTINUE
      IHE=1
  214 CONTINUE
      IOFORM=JSIZ
      IF (IOFORM.EQ.1) FORMA='Delta       '
      IF (IOFORM.EQ.2) FORMA='Final-Intial'
      IF (IOFORM.EQ.3) FORMA='Mixing      '
      IF  (IHE.EQ.1)  FORMA='Incorrect   '
  217 IQU=0
      IF (EOLD) WRITE(ISTDO,610) A, FORMA
  610 FORMAT (/,' Format of line ',I2,' is ',A12)
      IF (.NOT.EOLD) WRITE(ISTDO,22)
      WRITE(ISTDO,617)
  617 FORMAT (' Input format: 1.Delta, 2.Final-Intial, 3.Mixing')
      IF (EOLD) WRITE(ISTDO,613)
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.EQ.'?') CALL SOL(4,IQU)
      IF (IQU.EQ.1) GO TO 217
      IF (PLINE.NE.BLANK) GO TO 215
      IF (.NOT.EOLD) CALL SOL(4,IQU)
      IF (IQU.EQ.1) GO TO 217
      IF (IHE.NE.1) GO TO 219
      WRITE(ISTDO,612) CERR
  612 FORMAT (' ERROR! Format is incorrect so it must be changed!',A)
      GO TO 217
C
   42 FORM=0
      CALL UPCS(PLINE(1:30))
      IF (PLINE(1:3).EQ.'DEL') FORM=1
      IF (PLINE(1:3).EQ.'FIN') FORM=2
      IF (PLINE(1:3).EQ.'MIX') FORM=3
      IF (FORM.NE.0) GO TO 48
      CALL SOL(4,IQQ)
      GO TO 217
C
  219 CONTINUE
      FORM=IOFORM
      ICHANFORM=0
      GO TO 216
C
  215 CONTINUE
      IF (EOLD) ICHANFORM=1
      READ(PLINE,603,ERR=42) FORM
   48 IF (FORM.EQ.IOFORM) ICHANFORM=0
      IF (FORM.GT.3.OR.FORM.LT.1) GO TO 217
  216 CONTINUE
      IF (FORM.NE.1) GO TO 218
C
C         DELTA INPUT
C
  220 CONTINUE
      IQR=0
      IF (IND.NE.0) CALL SOL(1,IQR)
      IND=0
      IF (IQR.EQ.1) GO TO 220
      IF (EOLD.AND.ICHANFORM.EQ.0) WRITE(ISTDO,611) LINE(A)(3:11)
  611 FORMAT (//,' Old value = ',A8)
      IF (.NOT.EOLD) WRITE(ISTDO,22)
      WRITE(ISTDO,620)
  620 FORMAT(' Input delta.')
      IF (EOLD.AND.ICHANFORM.EQ.0) WRITE(ISTDO,613)
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.EQ.'?'.OR.(PLINE.EQ.BLANK.AND.(.NOT.EOLD)))
     *    CALL SOL(1,IQR)
      IF (.NOT.(PLINE.EQ.BLANK .AND. EOLD)) GO TO 33
      CDELT=LINE(A)(3:11)
      GO TO 158
C
   33 IF (IQR.EQ.1) GO TO 220
      CALL RNDF(PLINE,CDELT,8,ITYP0)
      IF (ITYP0.NE.1) GO TO 158
      IND=1
      ITYP0=0
      GO TO 220
C
  158 WRITE(NLINE,528) NELT,CDELT(1:8)
  528 FORMAT (A2,A8)
C
C         CHECK WHETHER DELTA & ELEMENT ARE OK
C
      CALL CHEK(NLINE,ICHEK)
      IF (ICHEK.EQ.1) GO TO 225
      IF (IADD.EQ.0) ICHANFORM=0
      IF (IOLD.NE.0) GO TO 210
      IEDIT=1
      LINE(A)=NLINE
      GO TO 210
C        WRITE NEW LINE
  225 LINE(A)=NLINE
      ICHANFORM=0
      IEDIT=0
      IF (IADD.EQ.1.AND.IFORM.EQ.0) GO TO 233
      IFORM=0
      IDIFF=IDIFF-1
      IF (IDIFF.LE.0) GO TO (210,201) IOLD+1
      GO TO 89
C
C          FINAL CONCEN INPUT
C
  218 CONTINUE
      CALL INPT('Input concentration of final solution    ',
     *           CFINAL,LINE(A),3)
      IF (IQUIT.EQ.1) GO TO 60
      IF (FORM.EQ.3) GO TO 226
C
C         INTIAL CONCEN INPUT
C
      CALL INPT('Input concentration of intial solution   ',
     *           CINTIAL,LINE(A),12)
      IF (IQUIT.EQ.1) GO TO 60
      WRITE(NLINE,529) NELT, CFINAL(1:8), CINTIAL
  529 FORMAT (A2,A8,A10)
C
C         CHECK WHETHER LINE IS OK
C
      CALL CHEK(NLINE,ICHEK)
      IF (ICHEK.EQ.1) GO TO 227
      IF (IADD.EQ.0) ICHANFORM=0
      IF (IOLD.NE.0) GO TO 210
      IEDIT=1
      LINE(A)=NLINE
      GO TO 210
C         WRITE NEW LINE
  227 LINE(A)=NLINE
      IEDIT=0
      ICHANFORM=0
      IF (IADD.EQ.1.AND.IFORM.EQ.0) GO TO 233
      IFORM=0
      IDIFF=IDIFF-1
      IF (IDIFF.LE.0) GO TO (210,201) IOLD+1
      GO TO 89
C
C         INTIAL * 1 AND INTIAL * 2 INPUT
C
  226 CONTINUE
      CALL INPT('Input concentration of intial solution #1',
     *           CINTIAL,LINE(A),12)
      IF (IQUIT.EQ.1) GO TO 60
      CALL INPT('Input concentration of intial solution #2',
     *   CINTI2,LINE(A),22)
      IF (IQUIT.EQ.1) GO TO 60
      WRITE(NLINE,530) NELT,CFINAL(1:8),CINTIAL,CINTI2
  530 FORMAT(A2,A8,2A10)
C
C         CHECK WHETHER LINE IS OK
C
      CALL CHEK(NLINE,ICHEK)
      IF (ICHEK.EQ.1) GO TO 228
      IF (IADD.EQ.0) ICHANFORM=0
      IF (IOLD.NE.0) GO TO 202
      IEDIT=1
      LINE(A)=NLINE
  202 IF (IFORM.EQ.0) GO TO 210
      GO TO 210
C         WRITE NEW LINE
  228 LINE(A)=NLINE
      ICHANFORM=0
      IEDIT=0
      IF (IADD.EQ.1.AND.IFORM.EQ.0) GO TO 233
      IFORM=0
      IDIFF=IDIFF-1
      IF (IDIFF.LE.0) GO TO (210,201) IOLD+1
      GO TO 89
C
C        PHASE DATA
C
  208 CONTINUE
      OLDADD=((IOLD.EQ.1.AND.IADD.EQ.0).OR.IEDIT.EQ.1)
      IF (.NOT.OLDADD) GO TO 190
      WRITE(ISTDO,191)
  191 FORMAT (' Do you wish to edit phase 1. by line or 2. by piece?')
      READ(ISTDI,501) PLINE
      IF (PLINE.NE.'*') GO TO 527
  166 IQUIT=1
      GO TO 60
C
  527 READ(PLINE,192,ERR=193) I
  192 FORMAT (I1)
      IF (I.EQ.1) GO TO 222
      IF (I.EQ.2) GO TO 131
  193 WRITE(ISTDO,194)
  194 FORMAT (/,6X,'There are two ways to edit phases.  The first',/,' s
     *imply asks you for a new phase from the phase list.',/,' The secon
     *d method runs through every varible in the',/,' phase and asks you
     * whether you wish to keep the old',/,' value or input a new one.',
     *//)
      GO TO 208
C
  190 IF (IPHAS.EQ.1) GO TO 222
      LINE(A)=BLANK
      NOELT=A-2-LBLOK(K-1)
      NOPHAS=NOELT
      IF (FORM.EQ.3) NOPHAS=NOELT-1
      WRITE(ISTDO,141) NOPHAS
  141 FORMAT (' At least ',I2,' phases must be input.',/)
      LBLOK(K)=A
      A=A+1
      IOUT=1
      IF (A.GT.MXLIN) CALL XCES(0,0,IOUT)
      IF (IQUIT.EQ.1) GO TO 60
      IF (IOUT.EQ.0) GO TO 142
      K=K+1
      IPHAS=1
  222 IF (OLDADD) WRITE(ISTDO,200) LINE(A)(1:8)
  200 FORMAT (/,' Old phase name = ',A8)
      IF (.NOT.OLDADD) WRITE(ISTDO,22)
      WRITE(ISTDO,618)
  618 FORMAT (' Input phase number (type ''LIST'' to see phases and thei
     *r corresponding numbers).')
      IF (OLDADD) WRITE(ISTDO,613)
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.EQ.'LIST'.OR.PLINE.EQ.'list') GO TO 224
      IF (.NOT.(PLINE.EQ.'?'.OR.(.NOT.OLDADD.AND.PLINE.EQ.' ')))
     *    GO TO 223
   69 WRITE(ISTDO,29) FLIN
   29 FORMAT (//,6X,'There is a list of pre-made phases which are refere
     *d to by number.  If',/,' you type ''LIST'' the list will be printe
     *d out.  If you type ',I3,', the number',/,' of **OTHER*, you will'
     *,
     *' be able to construct your own phase.  Phases can be'/' minerals,
     * gasses, or ion exchangers.  Each phase is follewed by a list of',
     */,' its component elements (not including Oxygen and Hydrogen) fol
     *lowed by their',/,' stoichiometric coefficients for the phase.  If
     * you are studying oxidation',/,' and reduction in your system, the
     * "element" RS, followed by the phases'' oper-',/,' ational valence
     * must be included.',//)
      GO TO 222
C
C            LIST OF PHASES
C
  224 WRITE(ISTDO,621)
  621 FORMAT (' List of phases and their corresponding numbers.')
      I=1
      IJ=1
   53 JJ=I+1
      KK=JJ+1
      IF (I.LT.60*IJ) GO TO 523
      WRITE(ISTDO,531)
  531 FORMAT (' Hit RETURN to see next page or enter number of phase to'
     *' use.')
      IJ=IJ+1
      READ(ISTDI,628) BANS
      IF (BANS.NE.'* ') GO TO 520
      IQUIT=1
      GO TO 60
C
  520 IF (BANS.EQ.'  ') GOTO 523
      READ(BANS,603,ERR=523) II
      GOTO 300
  523 IF (KK.EQ.FLIN) GO TO 146
      IF (JJ.EQ.FLIN) GO TO 147
      IF (I.NE.FLIN) GO TO 146
      WRITE(ISTDO,518) I,FLINE(I)
  518 FORMAT (1X,I3,': ',A10)
      GO TO 148
C
  147 WRITE(ISTDO,519) I,FLINE(I),JJ,FLINE(JJ)
  519 FORMAT (1X,I3,': ',A10,10X,I3,': ',A10)
      GO TO 148
C
  146 WRITE(ISTDO,619) I,FLINE(I),JJ,FLINE(JJ),KK,FLINE(KK)
  619 FORMAT (1X,I3,': ',A10,10X,I3,': ',A10,10X,I3,': ',A10)
  148 IF (I.EQ.FLIN.OR.I+1.EQ.FLIN.OR.I+2.EQ.FLIN) GO TO 222
      I=I+3
      GO TO 53
C
  223 IF (PLINE.NE.BLANK) GO TO 145
      NLINE=LINE(A)
      GO TO 128
C
  145 READ(PLINE,603,ERR=69) II
  300 IF (II.EQ.0) GO TO 224
      IF (II.NE.FLIN) GO TO 126
  131 IF (OLDADD) WRITE(ISTDO,182) LINE(A)(1:8)
  182 FORMAT (//,' Old phase name : ',A8)
      IF (.NOT.OLDADD) WRITE(ISTDO,22)
   22 FORMAT (/)
      WRITE(ISTDO,507)
  507 FORMAT (' Input phase name.')
      IF (OLDADD) WRITE(ISTDO,613)
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.NE.'?'.AND.(PLINE.NE.BLANK.OR.OLDADD))GO TO 127
      WRITE(ISTDO,508)
  508 FORMAT (///,6X,'"PHASE NAME" is an eight letter name of the minera
     *l whose',/,' concentration is to be found.  Phases must not be der
     *ivations',/,' of each other.  Example:  CaCO3, MgCO3, and CaMg(CO3
     *)2 cannot',/,' all be phases because : CaCO3 + MgCO3 -> CaMg(CO3)2
     *.')
      GO TO 131
C      "OTHER" PHASE INPUT
  127 NPHAS=PLINE(1:8)//'  '
      IF (OLDADD.AND.PLINE.EQ.BLANK) NPHAS=LINE(A)(:10)
      IF (.NOT.OLDADD) GO TO 143
      IF (PLINE.NE.BLANK) NPHAS(9:10)=LINE(A)(9:10)
      DO 183 IJK=1,7
      IS=10*IJK+1
      IF=10*(IJK+1)
      SPACE=LINE(A)(IS:IF)
      READ(SPACE,21) PELT2(1,IJK),PCOEFF2(1,IJK)
   21 FORMAT (A2,F8.3)
      IF (PELT2(1,IJK).EQ.'  ') GO TO 184
  183 CONTINUE
  184 NUMEL=IJK-1
  143 IF (OLDADD) WRITE(ISTDO,185) NUMEL
  185 FORMAT (//,' Old number = ',I2)
      IF (.NOT.OLDADD) WRITE(ISTDO,22)
      WRITE(ISTDO,510)
  510 FORMAT (' Input number of elements in phase (excluding O and H)
     *.')
      IF (OLDADD) WRITE(ISTDO,613)
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.NE.'?'.AND.(PLINE.NE.BLANK.OR.OLDADD))GO TO 132
  133 WRITE(ISTDO,511)
  511 FORMAT (///,6X,'After the mineral, all elements associated with',/
     1,' it must be inputed, excluding O and H. There can be',/,' from o
     2ne to seven elements in a phase. ')
      GO TO 143
C
  132 READ(PLINE,602,ERR=133) INTI
  602 FORMAT (I2)
      IF (INTI.EQ.0.AND.OLDADD) INTI=NUMEL
      IF (INTI.GT.7.OR.INTI.LT.1) GO TO 133
C
C         ELEMENT LOOP
C
      DO 134 I=1,INTI
C
C        INPUT ELEMENT
C
  135 NOLD=(OLDADD.AND.I.LE.NUMEL)
      IJK=0
      IF (I.EQ.1) CALL NLTS(IQQ,1)
      IQQ=0
      IF (NOLD) WRITE(ISTDO,186) PELT2(1,I)
  186 FORMAT (//,' Old element = ',A2)
      IF (.NOT.NOLD) WRITE(ISTDO,22)
      WRITE(ISTDO,512) I
  512 FORMAT (' Input letter code of element #',I1)
      IF (NOLD) WRITE(ISTDO,613)
      READ(ISTDI,501) PLINE
      IF (PLINE.NE.'*') GO TO 157
      IQUIT=1
      GO TO 60
C
  157 IF (PLINE.EQ.'?'.OR.PLINE.EQ.BLANK.AND.(.NOT.NOLD))
     *    CALL NLTS(IJK,0)
      IF (IJK.EQ.1) GO TO 135
      IF (NOLD.AND.PLINE.EQ.BLANK) PLINE=PELT2(1,I)//BLANK
      IF (PLINE(3:LEN(PLINE)).EQ.BLANK) GO TO 156
      WRITE(ISTDO,609)
      PLINE='?'
      GO TO 157
C
C         COEFFICIENT INPUT
C
  156 DO 172 KI=1,2
      IF (ICHAR(PLINE(KI:KI)).GE.97.AND.ICHAR(PLINE(KI:KI)).LE.121)
     *    PLINE(KI:KI)=CHAR(ICHAR(PLINE(KI:KI))-32)
  172 CONTINUE
      IF (PLINE(1:1).NE.' ') GO TO 203
      PLINE(1:1)=PLINE(2:2)
      PLINE(2:2)=' '
  203 NLTI=PLINE(1:2)
  136 IF (NOLD) WRITE(ISTDO,187) PCOEFF2(1,I)
  187 FORMAT (//,' Old coefficient = ',F8.3)
      IF (.NOT.NOLD) WRITE(ISTDO,22)
      WRITE(ISTDO,513) I
  513 FORMAT (' Input stoichiometric coefficient for element #',I1,' in'
     *,' phase')
      IF (NOLD) WRITE(ISTDO,613)
      READ(ISTDI,501) PLINE
      IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') GO TO 60
      IF (PLINE.NE.'?') GO TO 137
  138 WRITE(ISTDO,514)
  514 FORMAT (///,6X,'The stoihciometric coefficient is the number of',/
     *,' times the element appears in the phase mineral.  For',/,' redox
     * this number is the operational valence of the',/,' phase.',//)
      GO TO 136
C      READ NUMBER
  137 IF (.NOT.(NOLD.AND.PLINE.EQ.BLANK)) GO TO 37
      COEFF=PCOEFF2(1,I)
      GO TO 188
   37 READ(PLINE,'(F20.10)',ERR=138) COEFF
  188 IF (9999.999D0.GE.COEFF.AND.COEFF.GE.-999.999D0) 
     &    FORMT1='(A2,F8.3)'
      IF (999.999D0.GE.COEFF.AND.COEFF.GE.-99.999D0)
     &    FORMT1='(A2,F7.3,1X)'
      IF (99.999D0.GE.COEFF.AND.COEFF.GE.-9.999D0)
     &    FORMT1='(A2,1X,F6.3,1X)'
      IF (9.999D0.GE.COEFF.AND.COEFF.GE.0D0) FORMT1='(A2,1X,F5.3,2X)'
      WRITE(NLT(I),FORMT1) NLTI,COEFF
  134 CONTINUE
      CHINT=CHAR(INTI+48)
      FMT='(A10,'//CHINT//'A10)'
      WRITE(NLINE,FMT) NPHAS, (NLT(I),I=1,INTI)
      GO TO 128
C       NUMBERED PHASE INPUT
  126 IF (II.LT.FLIN.AND.II.GE.1) GO TO 129
      WRITE(ISTDO,509) CERR
  509 FORMAT (' ERROR! No such phase!',A)
      GO TO 224
C
  129 NLINE=FLINE(II)
  128 WRITE(ISTDO,173)
  173 FORMAT(' Does every model have to contain this phase?')
      IF (NLINE(9:9).EQ.'F')  WRITE(ISTDO,174) 'on '
      IF (NLINE(9:9).NE.'F')  WRITE(ISTDO,174) 'off'
  174 FORMAT(' Hit <RETURN> to keep force ',a3)
      READ(ISTDI,628) ANS
      IF (ANS.EQ.'N'.OR.ANS.EQ.'n') GOTO 175
      IF (ANS.EQ.' ') GOTO 179
      IF (ANS.EQ.'Y'.OR.ANS.EQ.'y') GOTO 176
      IF (ANS.EQ.'*') GOTO 166
      WRITE(ISTDO,178)
      GOTO 128
  178 FORMAT(' When force is on, every combination of phases checked'
     1,' by the program will contain the phase.'//)
  175 NLINE(9:9)=' '
      GOTO 179
  176 NLINE(9:9)='F'
  179 WRITE(ISTDO,164)
  164 FORMAT(' Enter reaction possibilities for this phase:'
     *,/,' 1. Dissolution (in-gassing),'
     *,' 2. Precipitation (out-gassing), or 3. Either?')
      IF (NLINE(10:10).EQ.'+') WRITE(ISTDO,165) ' Dissolution  '
      IF (NLINE(10:10).EQ.'-') WRITE(ISTDO,165) ' Precipitation'
      IF (NLINE(10:10).NE.'+'.AND.NLINE(10:10).NE.'-') WRITE(ISTDO,165)
     *' Either       '
  165 FORMAT (' Hit <RETURN> for ',a13)
      READ(ISTDI,628) ANS
      IF (ANS.EQ.'1') NLINE(10:10)='+'
      IF (ANS.EQ.'2') NLINE(10:10)='-'
      IF (ANS.EQ.'3') NLINE(10:10)=' '
      IF (ANS.EQ.'*') GOTO 166
      IF (ANS.EQ.'1'.OR.ANS.EQ.'2'.OR.ANS.EQ.'3'.OR.ANS.EQ.' ') GOTO 169
      WRITE(ISTDO,167)
  167 FORMAT(' This allows a particular phase to be limited to a posit'
     1,'ive or a negative change in concentration.'/)
      GOTO 179
  169 CALL CHEK(NLINE,ICHEK)
      IF (ICHEK.EQ.1) GO TO 189
      LINE(A)=NLINE
      IEDIT=1
      GO TO 208
C
  189 IEDIT=0
      IF (IOLD.EQ.1.OR.NOPHAS-A+LBLOK(K-1).LE.0) GO TO 153
      WRITE(ISTDO,152) NOPHAS-A+LBLOK(K-1)
  152 FORMAT (' Number of phases left to input is ',I2,/)
  153 LINE(A)=NLINE
      IF (IOLD.EQ.0) A=A+1
      IOUT=1
      IF (A.GT.MXLIN) CALL XCES(0,0,IOUT)
      IF (IQUIT.EQ.1) GO TO 60
      IF (IOUT.EQ.0) GO TO 142
C
C            CHECK WHETHER ALL PHASES FOR INPUT
C                 DATA HAVE BEEN INPUTED
C
      IF (IOLD.EQ.1.OR.NOPHAS-A+LBLOK(K-1)+1.GT.0) GO TO 38
      WRITE(ISTDO,701)
  701 FORMAT (' You have entered the required number of phases.'
     1/,' To enter additional phases now, type ''y''.'/' To stop now,'
     2,' just press <Enter>.')
      READ(ISTDI,628) ANS
      IF (ANS.eq.'Y'.or.ANS.eq.'y') go to 38
      LBLOK(K)=A
      LINE(A)=BLANK
      DO 159 I=LBLOK(K-2)+1,LBLOK(K)
  159 OLINE(I-LBLOK(K-2))=LINE(I)
      NOLINE=LBLOK(K)-LBLOK(K-2)
      LOBLOK=LBLOK(K-1)-LBLOK(K-2)
      FILE=BLANK
      CHECK=.FALSE.
      IOLD=1
      LIN=A
      NBLOK=K/2
      GO TO 142
C
   38 IDIFF=IDIFF-1
      IF (IDIFF.GT.0) GO TO 105
      IADD=0
      GO TO (208,201) IOLD+1
C
C        END INPUT
C
   45 WRITE(ISTDO,623)
  623 FORMAT (' Do you wish to make any other models?')
      CALL RANS(IWISH)
      IF (IQUIT.EQ.1) GO TO 60
      GO TO (181,47) IWISH+1
      WRITE(ISTDO,521)
  521 FORMAT (//,6X,'BALANCE can be run more than once from the same fil
     *e.',/,' Another model only needs to be appended to this one.  BALN
     *',/,' INPT does this automatically when this question is answered'
     *,/,' yes and begins to prompt you for input.',//)
      GO TO 45
C        INTIALIZE FOR APPENDING MODEL
   47 CALL MODN(IFLAG)
      IF (IQUIT.EQ.1) GO TO 60
      GO TO (49,142) IFLAG+1
   74 IPHAS=0
      ICHANFORM=0
      IOLD=0
      GO TO 207
C
  181 WRITE(ISTDO,627)
  627 FORMAT (' File done, O.K. to quit?')
      CALL RANS(IANS)
      IF (IQUIT.EQ.1) STOP
      K=2
      GO TO (142,60) IANS+1
      WRITE(ISTDO,522)
  522 FORMAT (//,6X,'If you have any suspicion that something in your fi
     *le is',/,' wrong, answer no to this question.  BALN INPT will then
     * take',/,' you to your first model so you can see if it needs to b
     *e edited',/,' further.  Look for ERROR messages and use the RUN co
     *mmand to',/,' find any other errors.  Use the NEXT command to go f
     *rom one model',/,' to the next.  Once you have seen all your model
     *s, you can leave',/,' BALN INPT by answering yes to this question.
     *',//)
      GO TO 181
C       WRITE FILE
   60 IF (.NOT.CHECK2) GO TO 625
      OPEN (RWUNIT,FILE=NEFLE,ERR=625)
      CLOSE (RWUNIT,STATUS='DELETE')
  625 IF (IOLD.EQ.1) CLOSE (RUNIT)
      LIN=LBLOK(2*NMOD)
      IF (IOLD.EQ.0.AND.IQUIT.EQ.1) LIN=A
      OPEN (WUNIT,FILE=NEFLE)
      WRITE(WUNIT,3501) (LINE(I),I=1,LIN)
 3501 FORMAT (A79)
      CLOSE (UNIT=WUNIT)
      IF (IQUIT.EQ.1) STOP 'PROGRAM ABORTED'
C          RUN BALANCE OR QUIT
   55 WRITE(ISTDO,629)
  629 FORMAT (' Do you wish to make a permanent file of the results?')
      CALL RANS(ICHEK)
      IF (IQUIT.EQ.1) STOP
      GO TO (57,56) ICHEK+1
      WRITE(ISTDO,526)
  526 FORMAT (//,6X,'A permanent file of the answers to the solution dat
     *a in',/,' your models can be made.  Just answer yes to this questi
     *on',/,' and BALN INPT will ask you for the name of the file you wi
     *sh',/,' to store the answers in. BALN INPT will print out the mod
     *el',/,' numbers of the models which have some error which prevents
     * the',/,' calculation of the answers.  In the new file, the specif
     *ic prob-',/,' lem will be printed, if there is one.'//)
      GO TO 55
C
   56 WRITE(ISTDO,505)
  505 FORMAT (//,' Answer file?')
      READ(ISTDI,110) OFILE
      IF (OFILE.EQ.'*') STOP
      IF (OFILE.NE.'?') GO TO 41
   59 WRITE(ISTDO,46)
   46 FORMAT (//,6X,'Please enter the name of the file you wish to store
     * the',/,' answers to your solution data in.  BALN INPT will write'
     *,' the',
     */,' answers to each model, or the errors which prevent them from'
     *,/,' being calculated.',//)
      GO TO 56
C
   41 INQUIRE (FILE=OFILE,EXIST=CHECK2)
      IF (.NOT.CHECK2) GO TO 12
      WRITE(ISTDO,115) OFILE
      CALL RANS(IANS)
      GO TO (56,12) IANS+1
      WRITE(ISTDO,54)
      GO TO 12
C
   12 CLOSE (RUNIT)
      CLOSE (WUNIT)
      OPEN (RUNIT,FILE=NEFLE)
      OPEN (WUNIT,FILE=OFILE,ERR=59)
      CALL UPCS(NEFLE)
      CALL UPCS(OFILE)
      WRITE(ISTDO,195) NEFLE, OFILE
  195 FORMAT (' Your model file is named: ',/1X,A80,/,' Your answer file
     * is named: ',/,1X,A80)
      NRUN=0
      CALL BALN
      STOP '*** BALN INPT ***'
C
   57 CALL UPCS(NEFLE)
      WRITE(ISTDO,180) NEFLE
  180 FORMAT (' Your finished file is named: ',/,1X,A80)
      STOP'*** BALN INPT ****'
      END
C
C
C      SUB TO READ A NUMBER OFF A LINE IN ANY FORMAT
C        AND THEN TRANSFER THE NUMBER TO A STRING
C
      SUBROUTINE RNDF(LINE,CHARA,IFIELD,IERR)
      CHARACTER*80 LINE
      CHARACTER*10 CHARA
      INTEGER IFIELD, IERR
      CHARACTER *12 FMT,FMT2
      CHARACTER *2 IFRNT,X,PLCS
      INTEGER FRONT, DECIMAL, PLACES, I, LENGTH, IFRONT, IP, IW, IX
      REAL RNUM, MAX
      INCLUDE 'one.cb'
      INTEGER LENCHR
      EXTERNAL FRNT, DECI, LENCHR
      INTRINSIC CHAR, ABS
C
      IERR=0
C      FIND MAX VAULE NO. CAN HAVE
      MAX=0.0
      DO 10 I=-3,IFIELD-5
   10 MAX=MAX+9.0*10.0**I
C
C      FIND POSITIONS OF FIRST DIGIT OF NUMBER, DECIMAL POINT,
C                  AND LAST DIGIT OF NUMBER
C
      CALL FRNT(FRONT,LINE)
      CALL DECI(DECIMAL,LINE)
      LENGTH = LENCHR(LINE)
C      IF THE FIRST DIGIT IS THE DECIMAL POINT, THE BEGINNING OF THE
C       NUMBER IS PUT BACK ONE
      IF (FRONT.EQ.DECIMAL) FRONT=FRONT-1
C      NUMBER OF DIGITS BEFORE DECIMAL POINT IS IFRONT
      IFRONT=DECIMAL-FRONT
C      IF THE NUMBER IS TO BIG, RETURN WITH ERROR
      IF (IFRONT.LT.IFIELD) GO TO 2
    5 IERR=1
      RETURN
C      MAX NO. OF PLACES AFTER DECIMAL = PLACES
    2 PLACES=IFIELD-IFRONT-1
C      IF THERES LESS THAN MAX PLACES, PLACES IS SET TO NO. OF NO.S
C      BEYOND DECIMAL POINT, UNLESS THERES LESS THAN 3
      IF (LENGTH-DECIMAL.LT.PLACES) PLACES=LENGTH-DECIMAL
      IF (LENGTH-DECIMAL.LE.3) PLACES=3
C      TURN NUMBER INTO CHARACTER
      PLCS=CHAR(PLACES+48)
      IP = LENCHR (PLCS)
      IFRNT=CHAR(IFIELD+48)
C      IF IFIELD=10, THE GENERATED CHARACTER WILL BE :, OTHERWISE
C      IT WILL MATCH THE NUMBER
      IF (IFRNT.EQ.':') IFRNT='10'
      IW = LENCHR(IFRNT)
C      IF THERES NO SPACES BEFORE NO., DONT PUT SPACES IN FORMAT
      IF (FRONT.LE.1) GO TO 3
      X=CHAR(FRONT+47)
      IX = LENCHR(X)
C      CREATING FORMAT! ( (3X,F8.3) OR (10X,F8.4) OR (1X,F10.4) ETC.. )
      FMT='('//X(1:IX)//'X,F'//IFRNT(1:IW)//'.'//PLCS(1:IP)//')'
      GO TO 4
C      FORMAT WITHOUT aX
    3 FMT='(F'//IFRNT(1:IW)//'.'//PLCS(1:IP)//')'
C      READ LINE WITH CREATED FORMAT
    4 READ(LINE,FMT,ERR=5) RNUM
C      CHECK IF NO. IS TOO BIG
      IF (ABS(RNUM).LE.MAX) GO TO 7
      IF (RNUM) 6,5,8
    8 WRITE(ISTDO,101) RNUM
      GO TO 5
    6 WRITE(ISTDO,103) RNUM
      GO TO 5
    7 IF (ABS(RNUM).GT.999.999) WRITE(ISTDO,102)
C      OUTPUT FORMAT
      FMT2='('//'F'//IFRNT(1:IW)//'.'//PLCS(1:IP)//')'
C      WRITE THE NUMBER ON LINE SO YOU CAN WRITE IT AS A STRING
      WRITE(CHARA,FMT2) RNUM
      RETURN
C
  101 FORMAT (1X,F10.3,' is too large.')
  102 FORMAT (' WARNING! Input number is not between +999.999 and -999.9
     *99')
  103 FORMAT (1X,F10.3,' is too small.')
      END
C
C
C      SUB TO CHECK IF SOME STRING IS CORRECT
C
      SUBROUTINE CHEK(WORD,IFLAG)
      CHARACTER *(*) WORD
      INTEGER IFLAG
      INCLUDE 'one.cb'
      EXTERNAL RANS
C
      IFLAG = 0
  100 WRITE (ISTDO, 9000) WORD
      CALL RANS(IFLAG)
      IF (IQUIT.NE.1 .AND. IFLAG.GT.1) THEN
        WRITE (ISTDO, 9005)
        GO TO 100
      ENDIF
      RETURN
C
 9000 FORMAT (/, ' Is', /, 1X, A80, /, ' correct?', /)
 9005 FORMAT (' Do you think this line is correct?', /,
     & ' If so, answer yes and BALN INPT will keep it.', /)
      END
C
C
C  SUB DETERMINES THE INDEX OF FIRST NON-BLANK CHARACTER OF STRING
C
      SUBROUTINE FRNT(FRSTCH,LIN)
      CHARACTER *(*) LIN
      INTEGER FRSTCH, I
      INTRINSIC LEN
C
      DO 100 I = 1, LEN(LIN)
        IF (LIN(I:I).NE.' ') THEN
          FRSTCH = I
          GO TO 200
        ENDIF
 100  CONTINUE
      FRSTCH = 0
 200  CONTINUE
      RETURN
      END
C
C
C      SUB DETERMINES INDEX OF DECIMAL POINT, AND IF NO DECIMAL
C      POINT EXISTS, ADDS ONE TO THE END OF THE NUMBER
C
      SUBROUTINE DECI(DECIMAL,LIN)
      CHARACTER *(*) LIN
      INTEGER DECIMAL, I, N, LENCHR
      EXTERNAL LENCHR 
C
      N = LENCHR(LIN)
      DO 100 I = 1, N
        IF (LIN(I:I).EQ.'.') THEN
          DECIMAL = I
          GO TO 200
        ENDIF
 100  CONTINUE
      LIN(N+1:N+1) = '.'
      DECIMAL = N + 1
 200  CONTINUE
      RETURN
      END
C
C      SUB READS ANSWER AND SETS FLAG = TO
C      0=NO  1=YES  2=ERROR  3=QUESTION
C
      SUBROUTINE RANS(IANS)
      INCLUDE 'one.cb'
      CHARACTER*1 ANS
      INTEGER IANS
      EXTERNAL UPCS
C
      IANS = 0
      READ (ISTDI, '(A1)') ANS
      CALL UPCS(ANS)
      IF (ANS.EQ.'Y') THEN
        IANS = 1
      ELSEIF (ANS.EQ.'*') THEN
        IQUIT = 1
      ELSEIF (ANS.EQ.'?' .OR. ANS.EQ.' ') THEN
        IANS = 3
      ELSEIF (ANS.NE.'Y'.AND.ANS.NE.'N') THEN
        WRITE (ISTDO, 9005)
        IANS = 2
      ENDIF
      RETURN
C
 9005 FORMAT (' Answer "Y" or "N", "?" for information.')
      END
C
      SUBROUTINE UPCS(LINE)
C
C        This subroutine changes all the letters in a
C        line to upper case.
C
      CHARACTER *(*) LINE
      INTEGER I, ICH, N, LOWA, LOWZ
      INTRINSIC LEN, ICHAR, CHAR
C
      LOWA = ICHAR('a')
      LOWZ = ICHAR('z')
      N = LEN(LINE)
      DO 100 I = 1, N
        ICH = ICHAR(LINE(I:I))
        IF (ICH.GE.LOWA .AND. ICH.LE.LOWZ) LINE(I:I) = CHAR(ICH-32)
  100 CONTINUE
      RETURN
      END
C
C            SUB TO PRINT HELP MESSAGES
C
      SUBROUTINE HELP(PLINE)
      CHARACTER *80 PLINE
      CHARACTER *1 ANS,P
      INTEGER IASK
      INCLUDE 'one.cb'
      EXTERNAL UPCS
C
      IASK=0
      IF (PLINE(1:1).NE.'?'.AND.PLINE(1:1).NE.'/') GO TO 10
      P=PLINE(2:2)
      CALL UPCS(P)
C     IF P DOES NOT EQUAL ANY OF THE COMMANDS, PRINT ALL HELP
      IF (P.NE.'#' .AND. P.NE.'?' .AND. P.NE.'*' .AND. P.NE.'!' .AND.
     &    P.NE.'P' .AND. P.NE.'Q' .AND. P.NE.'N' .AND. P.NE.'A' .AND.
     &    P.NE.'D' .AND. P.NE.'R' .AND. P.NE.'M' .AND. P.NE.'F') GOTO 10
      IASK=1
      IF (P.EQ.'#') GO TO 11
      IF (P.EQ.'Q') GO TO 12
      IF (P.EQ.'N') GO TO 13
      IF (P.EQ.'M') GO TO 14
      IF (P.EQ.'A') GO TO 15
      IF (P.EQ.'D') GO TO 16
      IF (P.EQ.'P') GO TO 17
      IF (P.EQ.'R') GO TO 18
      IF (P.EQ.'?') GO TO 19
      IF (P.EQ.'*') GO TO 20
      IF (P.EQ.'F') GO TO 21
      IF (P.EQ.'!') GO TO 22
   10 WRITE(ISTDO,100)
   11 WRITE(ISTDO,101)
      IF (IASK.EQ.1) RETURN
   12 WRITE(ISTDO,102)
      IF (IASK.EQ.1) RETURN
      WRITE(ISTDO,103)
      READ(ISTDI,104) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
   13 WRITE(ISTDO,105)
      IF (IASK.EQ.1) RETURN
   14 WRITE(ISTDO,106)
      IF (IASK.EQ.1) RETURN
      WRITE(ISTDO,103)
      READ(ISTDI,104) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
   15 WRITE(ISTDO,107)
      IF (IASK.EQ.1) RETURN
   16 WRITE(ISTDO,108)
      IF (IASK.EQ.1) RETURN
      WRITE(ISTDO,103)
      READ(ISTDI,104) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
   17 WRITE(ISTDO,109)
      IF (IASK.EQ.1) RETURN
   18 WRITE(ISTDO,110)
      IF (IASK.EQ.1) RETURN
      WRITE(ISTDO,103)
      READ(ISTDI,104) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
   19 WRITE(ISTDO,111)
      IF (IASK.EQ.1) RETURN
   20 WRITE(ISTDO,112)
      IF (IASK.EQ.1) RETURN
      WRITE(ISTDO,103)
      READ(ISTDI,104) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
   21 WRITE(ISTDO,116)
      WRITE(ISTDO,117)
      IF (IASK.EQ.0) WRITE(ISTDO,103)
      IF (IASK.EQ.1) WRITE(ISTDO,115)
      READ(ISTDI,104) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
   22 WRITE(ISTDO,113)
      WRITE(ISTDO,114)
      READ(ISTDI,104) ANS
      IF (ANS.EQ.'*') IQUIT=1
      RETURN
C
C
  100 FORMAT (/,' The commands have the following effects:',/)
  101 FORMAT (' __ : (some line number)',//,6X,'Edit a specific line.  W
     *hen you input some line number,',/,' BALN INPT will display each p
     *art of the line and ask for a',/,' replacing value.  If the line c
     *ontains a phase, BALN INPT'/' will ask for a new phase number. ','
     *If the line is a blank or',/,' not contained within the model an a
     *ppropriate ERROR message',/,' will be printed.',/)
  102  FORMAT (' Q : Quit',//,6X,'Leave edit mode.  BALN INPT first chec
     *ks whether there',/,' are any serious errors in your file.  If not
     *, you leave your',/,' models and are given a chance to append a ne
     *w model.  To do',/,' so, see File handling.  If this chance is pas
     *sed by, you are',/,' given one last chance to look at the edited f
     *ile.  Then, you' ,/,' are given the chance to run BALANCE and writ
     *e the output to a',/,' file.  Finally, you leave BALN INPT.',/)
  103 FORMAT (' Hit RETURN to see more or N to quit.')
  104 FORMAT (A1)
  105 FORMAT (' N : Next model'//6X,'Go to the next model.  The model ',
     *'located after the cur-'/,' rent one will be printed out and you c
     *an begin editing it.'/' If you are currently at the last model, ',
     *'you will go to the'/,' first one.  If you have not changed all yo
     *ur solution data',/,' to the same format, this command will have n
     *o effect.  See',/,' ERROR messages for a method of correcting this
     * problem.',/)
  106 FORMAT (' M : Model number #',//,6X,'Going through models, looking
     * for the right one, using NEXT',/,' can be tiresome, especially wh
     *en there are a lot of models.  This'/' command allows you to go ',
     *'to any model which you know the number of.'/
     *' Simply type ''M'' ',
     *'and the number of the model.  Example:  ''M3'' would'/,' take you
     * to model #3.  If you do not type a number, BALN INPT goes',/,' to
     * model #1.  If you type ''M?'', BALN INPT will print out the title
     * of'/' each model, along with their line and model numbers.  ''M''
     * like NEXT',/,' and QUIT, checks the model to make sure it has no'
     *,
     * ' serious errors, and'/' if there are any, does not leave the mod
     *el.  See ERROR messages for',/,' more about this.',/)
  107 FORMAT (' A : Add',//,6X,'Add a line to model.',/)
  108 FORMAT (' D : Delete',//,6X,'Delete any line from the model.',/)
  109 FORMAT (' P : Print',//,6X,'Print the current model with line numb
     *ers by each line.'/' If the current model is longer than twenty ',
     *'lines BALN INPT'/,' will print out twenty lines.  To see the rest
     * of the model,',/,' you need to hit RETURN.  When the model is pri
     *nted out, any',/,' editing ERROR messages are appended.  See ERROR
     * messages for',/,' a full explaination.',/)
  110 FORMAT (' R : Run BALANCE',//,6X,'Use current model as an input fi
     *le to run BALANCE, and',/,' print out delta phases.  If there is a
     * problem with your file,',/,' a run-time error message will be pri
     *nted out.  Either the phase',/,' rule has been violated, meaning o
     *ne phase is a derivative of the',/,' others, or the intial solutio
     *ns are all zero with mixing format.'/' See ERROR messages for a ',
     *'complete explaination.  This command'/,' does not create a perman
     *ent file of the results; it is solely',/,' to aid you in discoveri
     *ng and preventing run-time errors, and',/,' help you choose phases
     * to use. A permanent file will be made',/,' when you exit BALN INP
     *T if you so request it.',/)
  111 FORMAT (' ? : Help',//,6X,'Explain to program user meaning of curr
     *ent commands.  For',/,' editing commands, entering the command aft
     *er the ''?'' will give',/,' you an explaination of that specific c
     *ommand (! for ERROR Mess-', /,' ages, F for file handling, # for L
     *ine to Edit).  Example:  ''??''',/,' would print out these two par
     *agraphs.'//6X,'In most of the program, BALN INPT will print out ',
     *'an explain-'/,' ation for any incorrect input, such as typing a c
     *haracter value',/,' when a number is needed.  When not used for so
     *me other command,'/' RETURN will work just as well.  If you ask ',
     *'for help when BALN'/,' INPT''s request is self-explanatory, the r
     *equest will be retyped.',/)
  112 FORMAT (' * : Abort program'//6X,'Leave the program immediatly, ',
     *'after writing whatever work'/,' had been done to the file.  Abort
     * works for any input to BALN'/' INPT, including ''Hit RETURN to ',
     * 'see more.''  This is not a rec-'/' commended way to leave the pr
     *ogram and should only be used as',/,' a last resort.',/)
  113 FORMAT (' ERROR messages',//,6X,'There are two types of ERROR mess
     *ages, ones that occur during',/,' editing, and ones that happen du
     *ring the running of BALANCE.  This',/,' first paragraph deals with
     * editing errors. The first happens when' ,/,' your solution data f
     *or the elements is not all the same.  To cor-'/' rect this, use ',
     *'one form of solution data on all your elements.  The'/,' second o
     *ccurs when either one of your elements is not contained in',/,' an
     *y of your phases or one of your phases does not contain any of you
     *r',/,' elements. To correct this, delete the element or phase caus
     *ing the',/' trouble, or add a phase or element which is related ',
     *'to the substance.',/)
  114 FORMAT (6X,'There are two run-time errors, as they are called.  Th
     *e first'/' type happens when, in a mixing solution, all initial ',
     *'solutions are zero.'/,' Make one of the solutions positive to cor
     *rect.  The second type is caused',/,' when one of your phases is a
     * derivative of the others, violating the phase'/' rule, such as ',
     *'CaCO3 + MgCO3 -> CaMg(CO3)2 or Ca/Mg ion exchange + Mg/Na ion'/,'
     * exchange -> 2*Ca/Na/Mg ion exchange. Sometimes this happens becau
     *se you',/,' have not used all the elements contained in the phases
     *.  If not, one of',/,' your phases must be deleted.  The program s
     *imply suggests one possible'/' phase to delete; there are other ',
     *'ones that could be deleted.',//,' Hit RETURN to quit.')
  115 FORMAT (' Hit RETURN to quit.')
  116 FORMAT (//,' File handling'//6X,'When you give BALN INPT a file ',
     *'name, the program reads in the entire'/,' file, even though it on
     *ly counts the first model as one of your models.'/' If the file ',
     *'fills BALN INPT''s memory, it drops any models over the hun-',/,'
     * dred line limit and gives you a warning. If you want to use the o
     *ther',/,' models in the file, you must quit BALN INPT and ask to m
     *ake another model',/,' from your old file.  You are given the choi
     *ce of either using the last',/,' model you used, or using the next
     * model in the file.  If you use up all',/,' the models in the file
     *, you can go to the beginning of the file again.'/' At anytime, ',
     *'you can begin another file, or input a new model yourself;'/,' ho
     *wever, once you do this, if you ask for your original file, you wi
     *ll',/,' start at the beginning of it.',/)
  117 FORMAT (6X,'BALN INPT never changes input files without asking you
     * whether',/,' you want to overwrite the file or not.  When BALN IN
     *PT drops trailing'/' lines because the file is too large, it is ',
     *'only deleting the models'/,' from its memory.  The input file rem
     *ains unaffected. An important'/' note:  input files must be in ',
     *'correct format.  BALN INPT assumes the'/' file is, and although '
     *,'it can correct some errors, many are beyond'/' BALN INPT''s gras
     *p and will cause the program to fail.',/)
C
      END
C
C
C      WRITES OUT INFORMATION ONE ELEMENT INPUT AND SETS FLAG = 1
C
      SUBROUTINE NLTS(II,III)
      INCLUDE 'one.cb'
      CHARACTER *16 ACELE(20)
      INTEGER ILEN, I, II, III
      DATA ACELE(1)/'AL - Aluminum   '/,ACELE(2)/'BA - Barium     '/,
     *     ACELE(3)/'C  - Carbon     '/,ACELE(4)/'CA - Calcium    '/,
     *     ACELE(5)/'F  - Fluoride   '/,ACELE(6)/'FE - Iron       '/,
     *     ACELE(7)/'K  - Potassium  '/,ACELE(8)/'MG - Magnesium  '/,
     *     ACELE(9)/'MN - Mangenese  '/,ACELE(10)/'N  - Nitrogen   '/,
     *     ACELE(11)/'NA - Sodium     '/,ACELE(12)/'P  - Phosphorus '/,
     *     ACELE(13)/'RS - Redox state'/,ACELE(14)/'S  - Sulfur     '/,
     *     ACELE(15)/'SI - Silicon    '/,ACELE(16)/'SR - Strontium  '/
      ILEN = 17
      DO 100 I = ILEN, 20
        ACELE(I) = ' '
 100  CONTINUE
      IF (III.EQ.0) WRITE (ISTDO, 9000)
      WRITE (ISTDO, 9005)
      DO 200 I=1,ILEN,3
        WRITE (ISTDO, 9010) ACELE(I), ACELE(I+1), ACELE(I+2)
 200  CONTINUE
      II = 1
      RETURN
C
 9000 FORMAT (///, 6X,
     & '''Element'' is a two-letter upper case standard abbrev-', /,
     & ' iation for the element considered.  If redox is considered,',
     & /,
     & ' ''RS'' must be one of the elements.  Each element must have a'
     & , /, ' source or sink in at least one of the phases.')
 9005 FORMAT (//, 6X,
     & 'List of element abbreviations used in phase data.', //)
 9010 FORMAT (1X, 3(A16,3X))
      END
C
C      SUB WRITES OUT INFO ON CONCENTRATION INPUT AND SETS FLAG = 1
C
      SUBROUTINE SOL(I, II)
      INCLUDE 'one.cb'
      INTEGER I, II
C      SET FLAG = 1
      II = 1
C      WRITE HELP MESSAGE
      IF (I.EQ.1) THEN
        WRITE(ISTDO,1)
      ELSEIF (I.EQ.2) THEN
        WRITE(ISTDO,2)
      ELSEIF (I.EQ.3) THEN
        WRITE(ISTDO,3)
      ELSEIF (I.EQ.4) THEN
        WRITE(ISTDO,4)
      ELSEIF (I.EQ.5) THEN
        WRITE(ISTDO,5)
      ELSEIF (I.EQ.6) THEN
        WRITE(ISTDO,6)
      ENDIF
      RETURN
C
    1 FORMAT (///,6X,'''Delta'' is the difference in concentration of th
     *e',/,' element in the intial and final solutions.  Units may',/,
     *' be molal, mmolal or nu-molal.  No distinction is made'/' between
     * molarity and molality.  Delta may range from',/,' +999.999 to -99
     *9.999',//)
    2 FORMAT (///,6X,'''Final concen.'' is the total concentration of th
     *e',/,' element in the final solution in mole, mmole, or nu-',/,' m
     *ole units.  Final concen. may range from +999.999',/,' to -999.999
     *',//)
    3 FORMAT (///,6X,'''Intial concen.'' is the total concentration of',
     */,' the element in the intial solution in mole, mmole, or',/,' nu-
     *mole units.  Intial concen. may range from',/,' +99999.999 to -999
     *99.999, but if it''s absolute vaule'/' is above 999.999 BALANCE ',
     *'will not print it out totally.',//)
    4 FORMAT (///,6X,'There are three types of solution data that can be
     * used'/' in BALANCE.  The first, DELTA, consists of the element ',
     *'name'/,' and the difference in concentration of the two solutions
     *',/,' (Final - Intial).  The second, FINAL-INTIAL, consists of the
     *',/,' element name followed by the final and then intial concen-',
     */,' trations of the element in the two solutions.  The third, MIX-
     *',/,' ING, is special because it is a case where two intial solu-'
     *,/,' tions mix in unknown proportions to form a final solution.',/
     *,' The program calculates the proportions of the two intial',/,' s
     *olutions, as well as finding the phase concentrations.',//,6X,'All
     * three types of data take molal, mmolal or nu-molal',/,' units. Wh
     *en the last one (MIXING) is used, there may be one',/,' more eleme
     *nt than phase.  Otherwise, the number of phases',/,' must be equal
     * or greater than the number of elements',//)
    5 FORMAT (///,6X,'''Intial concen*1'' is the total concentration of'
     *,/,' the element in the first mixing solution.  Units may'/' be ',
     *'molal, mmolal or nu-molal.  Intial concen*1 may'/,' range from +9
     *9999.999 to -99999.999, but if it''s ab-',/,' solute vaule is grea
     *ter than 999.999 BALANCE will not',/,' be able to fully print it o
     *ut.',//)
    6 FORMAT (///,6x,'''Intial concen*2'' is the total concentration of'
     *,/,' the element in the second mixing solution.  Units',/,' may be
     * molal, mmolal or nu-molal.  Intial concen*1 may',/,' range from +
     *99999.999 to -99999.999, but if it''s ab-',/,' solute vaule is gre
     *ater than 999.999 BALANCE will not'/' be able to fully print it ',
     *'out.',//)
      END
C
C          SUB TO WRITE OUT DESRCIPTION OF PROGRAM
C
      SUBROUTINE DESC
      INCLUDE 'one.cb'
      CHARACTER*1 ANS
C          PAGE 1
      WRITE(ISTDO,100)
      WRITE(ISTDO,101)
      WRITE(ISTDO,102)
      READ(ISTDI,103) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
C          PAGE 2
      WRITE(ISTDO,104)
      WRITE(ISTDO,109)
      WRITE(ISTDO,102)
      READ(ISTDI,103) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
C          PAGE 3
      WRITE(ISTDO,105)
      WRITE(ISTDO,106)
      READ(ISTDI,103) ANS
      IF (ANS.EQ.'*') IQUIT=1
      IF (ANS.EQ.'*'.OR.ANS.EQ.'N'.OR.ANS.EQ.'n') RETURN
C          PAGE 4
      WRITE(ISTDO,107)
      WRITE(ISTDO,108)
      READ(ISTDI,103) ANS
      IF (ANS.EQ.'*') IQUIT=1
      RETURN
C          FORMAT STATEMENTS
  100 FORMAT (6X,'BALN INPT is a program designed to help define reactio
     *ns between minerals',/,' and ground water.  The program program de
     *rives balanced reactions of the form:',//,' Intial Solution + Reac
     *tant Phases -> Final solution + Product Phases'//' Where phases ',
     *'can be minerals, gases, or ion exchanges.  Each ground water mode
     *l',/,' consists of two parts, a list of elements and their concent
     *rations in two or',/,' three water samples taken along a flow path
     *, and a list of phases that could be',/ ,' the reactive constitute
     *s of the models. These two lists are preceded by the',
     */,' title of the system.')
  101 FORMAT (6X,'Each line of the element list consists of a standard e
     *lement abbreviation' /' and one to three numbers, representing ','
     *the change in concentration of the ele-',/,' ments between two wat
     *er samples.  The element list has three different ways of',/,' doi
     *ng this. The first, and most simple, is Delta, which is the differ
     *ence'/' of concentration (final - intial) of the element in the ',
     *'two samples.  The'/,' second, Final-Intial, consists of the conce
     *ntration of the element in the final' ,/,' and intial water. The l
     *ast method, Mixing, is used for a different type of',/,' model.  T
     *wo end-member waters mix in unknown proportions and a final water'
     *,' is'/' created. The program calculates the proportion of the two
     * end-member waters as',/,' well as the mass transfer. This type ne
     *eds three numbers, the two intial con-',/,' centrations and the fi
     *nal concentration.  It does not matter what units you use'/' in ',
     *'the program for concentrations, as long as you are consistent.')
  102 FORMAT (' Hit RETURN to see more or N to quit.')
  103 FORMAT (A1)
  104 FORMAT (6X,'The phase list is made up of mineral names followed by
     * their constituent',/,' elements (Oxygen and Hydrogen not included
     *) and the stoichiometric coefficients',/ ,' of each element for th
     *at phase.  As well as minerals; gases, ion exchangers'      ,/,' a
     *nd, in the special case of mixing, other solutions, can be used as
     * phases.',/,' The program has its own list of pre-made phases whic
     *h you may wish to use.',/)
  109 FORMAT (' Redox',/,6X,'When oxidation and reduction is a part of y
     *our system, electrons must be',/,' conserved.  To do this, RS must
     * be included in your element list.  With RS, the',/,' redox of eac
     *h considered solution must be listed.  The redox state of a ',/
     *' solution is'
     *  ,' defined as:',/,25X,'RS = SUM (i=1 to I) m(i)*v(i)',//,' Where
     * RS is the redox state of the solution, m(i) is the molality of th
     *e ith',/,'aqueous species, v(i) is the "operational valence" of th
     *e ith species, and I',/,' is the total number of species.  RS must
     * also be included as an "element" in',/,' each phase, where, inste
     *ad of a stoichiometric coefficient, the operational',/,' valence o
     *f the phase is listed.',//,6X,'Linear isotope balance equations ca
     *n also be included with the mass and',/,' electron balance equatio
     *ns if either the reaction is congruent or the fraction-', /,' atio
     *n between solution and solid is small enough to be ignored.')
  105 FORMAT (' Operation of BALN INPT',/,6X,'BALN INPT is an interactiv
     *e program, so you can alter the data you give it', /,' before it c
     *alculates the mass transfer.  However, this also means you cannot'
     */' press the BREAK key while the program is running or all your ',
     *'work will be lost.'/,' Anytime you do not understand something, t
     *ype a "?" and BALN INPT will explain'/,' it to you.  If you have a
     *n old file of data for BALANCE or BALN INPT, you can',/,' give thi
     *s file to BALN INPT and change the information in it.  Otherwise,'
     *,'BALN'/' INPT will begin asking you for data for a new model.  Fi
     *rst, BALN INPT asks for',/,' the title of the new model. You are t
     *hen asked for an element name, the type'  ,/,' of solution data th
     *at is to be used, and what the values of the solution data')
  106 FORMAT (' are.  BALN INPT keeps asking for elements until either t
     *he RETURN or the ENTER',/,' key is pushed by itself.  Then BALN IN
     *PT requests a phase number (typing "LIST"',/,' will print a list o
     *f pre-made phases and their corresponding numbers). Once all', /,'
     * the phases needed are chosen, BALN INPT will print out your new m
     *odel. A header' ,/,' telling what model number your model is, is p
     *rinted, and after it, the title of',/,' your system.  Element data
     * is next, with each element listed in the order you',/,' typed the
     *m in.  The solution data is printed after each element, in the ord
     *er'   ,/,' final concentration, first intial concentration, second
     * intial concentration;',/,' final concentration, intial concentrat
     *ion; or simply delta, depending on what',/,' kind of solution data
     * is being used.  A blank line is inserted between the',/,' solutio
     *n list and the phase list for readability.  Once your model is pri
     *nted',/,' out, you can begin editing it.  There are eight commands
     * to help edit your',/,' your model.  Hit RETURN to see them.')
  107 FORMAT (' (some line number) = Change some part of line X',/,' Q(u
     *it)',13X,'= Leave BALN INPT'/' M(ove to some mod.)= Go to model ',
     *'number X'/,' N(ext)',13X,'= Go to the next model',/,' P(rint)',12
     *X,'= List out the model',/,' R(un)',14X,'= Calculate mass transfer
     * for model',/,' ?(Question)',8X,'= Print out explaination',/,' *(A
     *bort)',11X,'= Leave BALN INPT immediatly',//,' At certain parts of
     * the program, a more detailed description of the commands',/,' can
     * be printed out.')
  108 FORMAT (' Hit RETURN to quit')
      END
C
C
C            SUB TO INTIALIZE FOR NEW MODEL
C
      SUBROUTINE MODN(IOPT)
      INCLUDE 'balninpt.cb'
      INCLUDE 'one.cb'
      CHARACTER *80 PLINE
      CHARACTER *10 BLANK
      CHARACTER *1 P
      LOGICAL OPE
      INTEGER LENGTH, IFLAG, I, IUNT, IJ, IOUT, IANS, IB, IOPT, LENCHR
      EXTERNAL LENCHR, UPCS, RANS, XCES
      DATA BLANK/'          '/
C          BEGIN SUB, ASK IF OLD FILE IS TO BE USED
      TEMP=FILE
      NMOD=NMOD+1
      LENGTH = 1
      IF (FILE.NE.'    ') LENGTH = LENCHR(FILE)
      CALL UPCS (FILE(:LENGTH))
   10 IF (.NOT.CHECK) GO TO 29
      WRITE(ISTDO,100) FILE(1:LENGTH)
      CALL RANS (IFLAG)
      IF (IQUIT.EQ.1) RETURN
      GO TO (29,13) IFLAG + 1
      WRITE(ISTDO,110)
      GO TO 10
C          ASK FOR NEW INPUT FILE
   29 WRITE(ISTDO,101)
      READ(ISTDI,102) PLINE
      IF (PLINE.NE.'?') GO TO 11
   37 WRITE(ISTDO,103) NEFLE
      FILE=TEMP
      GO TO 29
C          FIND OUT WHAT FILE IS
   11 IF (PLINE(1:1).EQ.'*') IQUIT=1
      IF (PLINE(1:1).EQ.'*') RETURN
      CALL UPCS(PLINE)
      IF (PLINE.EQ.BLANK) GO TO 12
      IF (PLINE.EQ.FILE) GO TO 13
      IF (PLINE.EQ.NEFLE) GO TO 37
      FILE=PLINE
      IFLENT=IFLEN
      INQUIRE (FILE=FILE,EXIST=CHECK,ERR=37)
      IF (CHECK) GO TO 38
      WRITE(ISTDO,109)
      FILE=TEMP
      GO TO 37
C          REWIND FILE AND RETURN
   38 OPEN (RUNIT,FILE=FILE)
      REWIND (RUNIT)
      CLOSE (RUNIT)
      IOPT=0
      RETURN
C          OLD FILE, NEW BLOCK
   13 IF (NMOD.GT.NBLOK) GO TO 32
   15 WRITE(ISTDO,104)
      READ(ISTDI,102) PLINE
      IF (PLINE.NE.BLANK.AND.PLINE.NE.'?') GO TO 16
   17 WRITE(ISTDO,105)
      GO TO 15
C          END OF FILE, USE PREVIOUS OR FIRST?
   32 IF (IFLEN.EQ.1) GO TO 14
   34 WRITE(ISTDO,111)
      READ(ISTDI,102) PLINE
      P=PLINE(1:1)
      CALL UPCS(P)
      IF (P.EQ.'*') IQUIT=1
      IF (IQUIT.EQ.1) RETURN
      IF (P.EQ.'1'.OR.P.EQ.'P') GO TO 14
      IF (P.EQ.'2'.OR.P.EQ.'F') GO TO 30
      WRITE(ISTDO,112)
      GO TO 34
C          USING NEXT FILE
   16 IF (PLINE.EQ.'*') IQUIT=1
      IF (PLINE.EQ.'*') RETURN
      P=PLINE(1:1)
      IF (P.EQ.'1'.OR.P.EQ.'P'.OR.P.EQ.'p') GO TO 14
      IF (P.NE.'2'.AND.P.NE.'N'.AND.P.NE.'n') GO TO 17
      NOLINE=LBLOK(K)-LBLOK(K-2)
      LOBLOK=LBLOK(K-1)-LBLOK(K-2)
      DO 18 I=1,NOLINE
   18 OLINE(I)=LINE(I+LBLOK(K-2))
      IOPT=1
      RETURN
C          USE MODEL AT BEGINNING OF FILE
   30 INQUIRE (FILE=FILE,OPENED=OPE,NUMBER=IUNT)
      IF (.NOT.OPE) GO TO 31
      CLOSE (IUNT)
   31 OPEN (11,FILE=FILE,ERR=55)
      REWIND (11)
      CLOSE(11)
      IOPT=0
      RETURN
   55 STOP 'error opening unit 11: file='
C          USE PREVIOUS MODEL
   14 LIN=LIN+NOLINE
   19 IF (LIN.LE.MXLIN) GO TO 20
      IF (NMOD.GT.NBLOK) GO TO 36
      WRITE(ISTDO,106) NBLOK, FILE(1:LENGTH)
      DO 21 I=LBLOK(2*NBLOK-2)+1,LBLOK(2*NBLOK)
   21 LINE(I)=BLANK
      LIN=LIN-LBLOK(2*NBLOK)+LBLOK(2*NBLOK-2)+1
      NBLOK=NBLOK-1
      GO TO 19
C          MOVE LINES AND LBLOKS DOWN TO MAKE SPACE
   20 LIN=LIN-NOLINE
      IF (NMOD.GT.NBLOK) GO TO 35
      DO 22 I=LIN,LBLOK(2*NMOD-2)+1,-1
   22 LINE(I+NOLINE)=LINE(I)
      IJ=2*NBLOK
      IF (2*NBLOK+2.GT.40) IJ=40
      DO 24 I=IJ,2*NMOD-1,-1
   24 LBLOK(I+2)=LBLOK(I)+NOLINE
C          WRITE PREVIOUS MODEL TO SPACE
   35 DO 23 I=1,NOLINE
   23 LINE(I+LBLOK(2*NMOD-2))=OLINE(I)
      LBLOK(2*NMOD-1)=LOBLOK+LBLOK(2*NMOD-2)
      LBLOK(2*NMOD)=NOLINE+LBLOK(2*NMOD-2)
      NBLOK=NBLOK+1
      K=2*NMOD
      LIN=LIN+NOLINE
      IOPT=1
      RETURN
C          USING PREVIOUS MODEL, CALL XCES
   36 LIN=LIN-NOLINE
      DO 33 I=LBLOK(2*NMOD-2),MXLIN
   33 LINE(I)=LINE(I-NOLINE)
      CALL XCES(0,1,IOUT)
      IOPT=1
      RETURN
C          USE PREVIOUS MODEL FOR INPUT?
   12 WRITE(ISTDO,107)
      CALL RANS(IANS)
      IF (IQUIT.EQ.1) RETURN
      GO TO (27,26) IANS+1
      WRITE(ISTDO,108)
      GO TO 12
C          USING LAST MODEL, NO FILE
   26 LIN=LIN+NOLINE
      IF (LIN.GT.MXLIN) GO TO 36
      IB=LBLOK(2*NMOD-2)
      DO 28 I=1,NOLINE
   28 LINE(IB+I)=OLINE(I)
      LBLOK(2*NMOD)=IB+NOLINE
      LBLOK(2*NMOD-1)=LOBLOK+IB
      K=2*NMOD
      A=LBLOK(K-1)+1
      IOPT=1
      RETURN
C          INPUTING FILE, MODELS FROM PREVIOUS FILE EXIST
   27 IF (NMOD.GT.NBLOK) GO TO 25
      K=2*NMOD-1
      NBLOK=NBLOK+1
      A=LBLOK(K-1)+1
      IOPT=2
      RETURN
C          INPUTTING FILE, MOD FR PREV FL DNT EXIST
   25 K=2*NBLOK+1
      NBLOK=NBLOK+1
      A=LIN+1
      IF (A.GT.MXLIN) CALL XCES(1,0,IOUT)
      IF (IQUIT.EQ.1) STOP
      IOPT=2
      RETURN
C
C     FORMAT STATEMENTS
C
  100 FORMAT (' Old file = ',A,/,'Do you wish to use your old file?')
  101 FORMAT (' Enter name of existing model file. (If none hit <RETURN>
     *)')
  102 FORMAT (A80)
  103 FORMAT (//,6X,'The existing model file is a list of ground water m
     *odels,',/,' already in correct format, which you wish to alter.  I
     *f you',/,' wish to use your previous model, and it was entered dur
     *ing',/,' this editing session, hit <RETURN>.  Do not type the name
     * of',/,' your input model ,'/1x,A80,//)
  104 FORMAT (/,' Do you wish to use 1. the previous model or 2. the nex
     *t model as input?')
  105 FORMAT (//,6X,'BALN INPT now has in its memory the original of the
     * model',/,' you just edited.  You can use this model to create you
     *r next one.',/,' However, BALN INPT also has a model which is loca
     *ted after the',/,' first one in you reference file.  You must choo
     *se which of these',/,' files you wish to use.',/)
  106 FORMAT (' WARNING!  Due to memory limitations, trailing model ',I2
     *,' of ',A,' is begin dropped.'/)
  107 FORMAT (/,' Do you wish to use your previous model as input?')
  108 FORMAT (//,6X,'You can type the next model in; however, an alterna
     *tive',/,' exists.  If you answer yes to this question, BALN INPT c
     *opies',/,' your last model over, so you can use it as your next mo
     *del.',//)
  109 FORMAT (/,' ERROR!  The file you entered does not exist.')
  110 FORMAT (//6X,'If you answer yes to this question, BALN INPT will '
     *'use'/' your old file as input, either using the previous model, '
     *'or'/,' the next one, depending on your choice.  If you answer no,
     *',/,' you can either enter a new file to use, use your previous',/
     *,' model as it stands now, or you can type in the next model.',//)
  111 FORMAT (/,' Do you wish to 1. use the previous model or 2. use the
     * first model of this file.')
  112 FORMAT (//,6X,'You are now positioned at the end of this model fil
     *e.  You'/' can use the last model you used in this file or BALN ',
     *'INPT can'/,' rewind the file so you can start at the beginning mo
     *del.',//)
C
      END
C
C
C      SUB TO SAVE FILE IF OVER MXLIN(=100) LINES ARE USED
C
      SUBROUTINE XCES(IOVER,IOPT,IOUT)
      INTEGER IOVER, IOPT, IOUT
      INCLUDE 'balninpt.cb'
      INCLUDE 'one.cb'
      LOGICAL CHECK3
      CHARACTER*80 PLINE, NEWF
      CHARACTER*1 P
      INTEGER I, IANS, IUNT
      EXTERNAL UPCS, RANS
C
   13 IF (NBLOK.GT.NMOD) WRITE(ISTDO,110)
      WRITE(ISTDO,100)
      READ(ISTDI,101) PLINE
      P=PLINE(1:1)
      CALL UPCS(P)
      IF (P.EQ.'1'.OR.P.EQ.'C') GO TO 11
      IF (P.EQ.'2'.OR.P.EQ.'E') GO TO 12
      IF (P.EQ.'3'.OR.P.EQ.'Q'.OR.P.EQ.'*') IQUIT=1
      IF (IQUIT.EQ.1) GO TO 19
      WRITE(ISTDO,109)
      GO TO 13
C          QUIT BALNINPT
   19 IOLD=0
      A=MXLIN
      LIN=MXLIN
      RETURN
C          KEEP OLD FILE, EDIT IT
   12 IOLD=1
      LIN=LBLOK(2*NMOD-2)
      NMOD=NMOD-1
      K=2*NMOD
      IOUT=0
      RETURN
C          WRITE OLD FILE, BEGIN A NEW ONE
   11 IF (.NOT.CHECK2) GO TO 10
      OPEN (RWUNIT,FILE=NEFLE)
      CLOSE (RWUNIT,STATUS='DELETE')
   10 OPEN (WUNIT,FILE=NEFLE,STATUS='NEW')
      WRITE(ISTDO,103) NEFLE
      WRITE(WUNIT,101) (LINE(I),I=1,LBLOK(2*NMOD-2))
      CLOSE (WUNIT,STATUS='KEEP')
   20 WRITE(ISTDO,104)
      READ(ISTDI,105) NEWF
      IF (NEWF.NE.'?') GO TO 90
   30 WRITE(ISTDO,107) NEFLE
      GO TO 20
C          CHECK IF FILE EXISTS, IF BEGINNING INPUT
   90 IF (NEWF.EQ.'*') IQUIT=1
      IF (NEWF.EQ.'*') RETURN
      IF (NEWF.EQ.NEFLE) GO TO 30
      INQUIRE (FILE=NEWF,EXIST=CHECK3,ERR=30)
      IF (.NOT.CHECK3) GO TO 99
      WRITE(ISTDO,106) NEWF
      CALL RANS(IANS)
      IF (IQUIT.EQ.1) RETURN
      IF (IANS.NE.1) GO TO 20
      OPEN (11,FILE=NEWF)
      CLOSE (11,STATUS='DELETE')
   99 NEFLE=NEWF
      IFLEN=IFLENT
      FILE=TEMP
      IF (IOVER.EQ.0) GO TO 40
      K=1
      NMOD=1
      A=1
      IOUT=1
      RETURN
C          CONTINUE, PREVIOUS MODEL
   40 IF (IOPT.EQ.0) GO TO 17
      DO 18 I=1,NOLINE
   18 LINE(I)=OLINE(I)
      K=2
      NMOD=1
      NBLOK=1
      LIN=NOLINE
      LBLOK(1)=LOBLOK
      LBLOK(2)=NOLINE
      IOUT=1
      RETURN
C          CONTINUE, WRITE PART OF MODEL WHICH HAS BEEN MADE SO FAR
   17 DO 60 I=LBLOK(2*NMOD-2)+1,MXLIN
   60 LINE(I-LBLOK(2*NMOD-2))=LINE(I)
      IF (IOLD.EQ.1) GO TO 14
      A=A-LBLOK(2*NMOD-2)
      LBLOK(1)=LBLOK(2*NMOD-1)-LBLOK(2*NMOD-2)
      K=K-2*NMOD+2
      NMOD=1
      IOUT=1
      RETURN
C          READ IN REST OF FILE
   14 IUNT=5
      INQUIRE (FILE=FILE,OPENED=CHECK3,NUMBER=IUNT)
      IF (CHECK3) GO TO 50
      OPEN (IUNT,FILE=FILE)
   50 BACKSPACE(IUNT)
      I=MXLIN+1
   15 IF (I.GT.2*MXLIN+1) GO TO 70
      READ(IUNT,101,END=16) LINE(I-LBLOK(2*NMOD-2))
      I=I+1
      GO TO 15
C          ABORT IF THE FILE IS LONGER THAN 2*MXLIN(=200) LINES
   70 CHECK=.TRUE.
      WRITE(ISTDO,102)
      IQUIT=1
      RETURN
C          INTIALIZE FOR OLD FILE
   16 LIN=I-LBLOK(2*NMOD-2)-1
      NMOD=1
      K=2
      IOUT=2
      RETURN
C          FORMAT STATEMENTS
  100 FORMAT (' You have exceeded the one hundred line limit on file len
     *gth.',/,' You have three choices:  1. continue in a different file
     *,',/,' 2. edit what you have, or 3. quit.  Enter your choice.')
  101 FORMAT (A80)
  102 FORMAT (' You have over filled your second file too, so BALN INPT'
     *,' is aborting.')
  103 FORMAT (' Writing file:  ',/1x,A80)
  104 FORMAT (' Name of the new file?')
  105 FORMAT (A80)
  106 FORMAT (' Do you wish to overwrite: '/1x,A80,' ?')
  107 FORMAT (' The new file will be the file which contains any new wor
     *k',/,' you do now, as opposed to the old file which contains all',
     */,' the work you have already done.  Do not use the name of your i
     *nput file: '/1x,A80,//)
  109 FORMAT (//,6X,'You have three choices; all have advantages and dis
     *advantages.',/,' If you choose to continue making models, all your
     * work will be saved,'/' and you can continue working.  However, ',
     *'your previous work will be'/,' written to a file and become inacc
     *essible to you during this program',/,' session.  If you decide to
     * edit your previous models, the final model',/,' will be dropped f
     *rom your file, but you will be able to finish this',/,' file and b
     *egin a new one once you are satisfied that your models are as',/,'
     * you wish them.  Quitting will write all your work, cutting it off
     * at',/,' line one hundred.',//)
  110 FORMAT (' When BALN INPT reads a file in, all the models are read'
     *,'in, even'/' though only the first one is counted as a model.  No
     *w your trailing',/,' models (those not approved to appear in the f
     *inal file) exceed the one'/' hundred line limit.  If you do not ',
     *'want these trailing models, type'/,' edit for the next question a
     *nd any models that acceed the limit will',/,' be deleted.',/)
C
      END
C
C
C      SUB ASKS FOR CONCENTRATION INPUT FOR THE ELEMENTS
C
      SUBROUTINE INPT(INPUT,OUTPUT,LINE,I)
      INCLUDE 'one.cb'
      CHARACTER *41 INPUT
      CHARACTER *80 LINE, OLINE
      CHARACTER *10 OUTPUT
      LOGICAL EOLD
      INTEGER JJ, ISOL, IJ, I
      EXTERNAL SOL, RNDF
      INTRINSIC INT
C
      EOLD=((IOLD.EQ.1.OR.IEDIT.EQ.1).AND.IADD.EQ.0.AND.ICHANFORM.EQ.0)
      JJ=0
C      INTILIZE ERROR CODES
      IF (INPUT(24:24).EQ.'f') THEN
          ISOL=2
      ELSE IF (INPUT(40:40).EQ.' ') THEN
          ISOL=3
      ELSE IF (INPUT(41:41).EQ.'1') THEN
          ISOL=5
      ELSE
          ISOL=6
      ENDIF
    1 CONTINUE
      IJ=0
C      PRINT MESSAGE IF ERROR HAS OCCURRED
      IF (JJ.NE.0) CALL SOL(ISOL,IJ)
      JJ=0
C      REZERO IJ IF AN ERROR HAS OCCURRED
      IJ=0
C      WRITE THE OLD LINE IF NO EDITING HAS BEEN DONE
      IF (EOLD) WRITE(ISTDO,9) LINE(I:I+10)
      IF (.NOT.EOLD) WRITE(ISTDO,10)
      WRITE(ISTDO,3) INPUT
      IF (EOLD) WRITE(ISTDO,4)
      READ(ISTDI,5) OLINE
      IF (OLINE.EQ.'*') IQUIT=1
      IF (OLINE.EQ.'*') RETURN
      IF (OLINE.EQ.'?'.OR.(.NOT.EOLD.AND.OLINE.EQ.' '))
     *    CALL SOL(ISOL,IJ)
      IF (IJ.EQ.1) GO TO 1
      IF (OLINE.NE.' ') GO TO 6
      OLINE=LINE(I:I+10)
    6 CALL RNDF(OLINE,OUTPUT,8+2*INT((1+INT(ISOL/2.99))/1.99),JJ)
      IF (JJ.EQ.1) GO TO 1
      RETURN
    3 FORMAT (1x,A41)
    4 FORMAT (' Push <RETURN> to keep old one.')
    5 FORMAT (A80)
    9 FORMAT (/,' Old value = ',A10)
   10 FORMAT (/)
      END
C
      SUBROUTINE BALN
      INCLUDE 'balninpt.cb'
      INCLUDE 'one.cb'
      INTEGER I, ISOLN, J, ILOOP
      CHARACTER*80 TITLE
      EXTERNAL INIT, NEXT, SET, ROWCOL, SLNQ, PRINT
C
C        NEW VERSION OF BALANCE WHICH ACCEPTS A SET
C        OF PHASES WHICH EXCEEDS IN NUMBER THE NUMBER
C        OF ELEMENTS IN THE CHEMICAL ANALYSES AND TESTS
C        EVERY MASS BALANCE MODEL WHICH CAN BE DERIVED
C        FROM THE SET OF PHASES ENTERED
C
      IUNIT=WUNIT
      IF (NRUN.EQ.1) IUNIT=ISTDO
   10 CONTINUE
      READ(RUNIT,20,END=1000) TITLE
   20 FORMAT(A80)
      IF (NRUN.EQ.0) WRITE(WUNIT,30) TITLE
   30 FORMAT(///1X,A80///)
C
C             READ SOLUTION DATA
C
      I=1
      ISOLN=0
      IMIX=0
   40 CONTINUE
      READ(RUNIT,50,END=1000) ENAME(I),SFINAL(I),SINIT1(I),SINIT2(I)
   50 FORMAT(A2,F8.3,2F10.3)
      IF(SINIT1(I).GT.0.0D0) ISOLN=1
      IF(SINIT2(I).GT.0.0D0) IMIX=1
      IF(ENAME(I).NE.'        ') THEN
         IF (NRUN.EQ.0) WRITE(WUNIT,52) I,ENAME(I),SFINAL(I),SINIT1(I),
     *SINIT2(I)
   52    FORMAT(1X,I2,1X,A2,F8.3,2F10.3)
         I=I+1
         GO TO 40
      END IF
      WRITE(IUNIT,53)
   53 FORMAT(1X)
      NELTS=I-1
      DO 55 I=1,NELTS
      IF(IMIX.NE.1.AND.ISOLN.EQ.1) THEN
         EDELTA(I)=SFINAL(I)-SINIT1(I)
      ELSE
         EDELTA(I)=SFINAL(I)
      END IF
   55 CONTINUE
      NEQ=NELTS+IMIX
C
C             INITIALIZE VARIABLES
C
      DO 60 J=1,40
      TRANSFER(J)=' '
      DO 60 I=1,16
      PELT(J,I)='        '
   60 CONTINUE
C
C             READ PHASE DATA
C
      I=2*IMIX+1
  100 CONTINUE
      READ(RUNIT,110,END=112) PNAME(I),FORCE(I),TRANSFER(I),
     1   (PELT(I,J),PCOEF(I,J),J=1,7)
  110 FORMAT(A8,A1,A1,7(A2,F8.3))
      IF (FORCE(I).NE.'F') GOTO 113
      DO 111 ILOOP=I+1,2,-1
      PNAME(ILOOP)=PNAME(ILOOP-1)
      FORCE(ILOOP)=FORCE(ILOOP-1)
      TRANSFER(ILOOP)=TRANSFER(ILOOP-1)
      DO 116 J=1,7
      PELT(ILOOP,J)=PELT(ILOOP-1,J)
      PCOEF(ILOOP,J)=PCOEF(ILOOP-1,J)
  116 CONTINUE
  111 CONTINUE
      PNAME(1)=PNAME(I+1)
      FORCE(1)=FORCE(I+1)
      TRANSFER(1)=TRANSFER(I+1)
      DO 117 J=1,7
      PELT(1,J)=PELT(I+1,J)
      PCOEF(1,J)=PCOEF(I+1,J)
  117 CONTINUE
  113 IF(PNAME(I).NE.'        ') THEN
         I=I+1
         GO TO 100
      END IF
  112 CONTINUE
      NMINS=I-1
C
C             CALCULATE COMBINATIONS OF MINERALS AND
C             TEST RESULTING MODELS.
C
      MODTOT=0
      MODGOOD=0
      FIRST=.TRUE.
      CALL INIT
C             WRITE OUT PHASE DATA
      IF(IMIX.EQ.1) THEN
        IF (NRUN.EQ.0) WRITE(WUNIT,114)
  114   FORMAT(1X,' 1 INIT 1'/1X,' 2 INIT 2')
      END IF
      DO 118 I=IMIX*2+1,NMINS
      IF (NRUN.EQ.0) WRITE(WUNIT,115) I,PNAME(I),FORCE(I),TRANSFER(I),
     1   (PELT(I,J),PCOEF(I,J),J=1,7)
  115 FORMAT(1X,I2,1X,A8,A1,A1,7(A2,F7.3))
  118 CONTINUE
      IF (NRUN.EQ.0) WRITE(WUNIT,53)
C
C             TEST ALL COMBINATIONS
C
  200 CONTINUE
      MODTOT=MODTOT+1
      CALL NEXT
      IF(QUIT) THEN
         MODTOT=MODTOT-1
         WRITE(IUNIT,205) MODTOT, MODGOOD
  205 FORMAT(/I13,' MODELS WERE TESTED.'/
     1   I13,' MODELS WERE FOUND WHICH SATISFIED THE CONSTRAINTS.')
         WRITE(IUNIT,53)
         GO TO 10
      END IF
      CALL SET
      CALL ROWCOL
      IF(ARRAYOK) THEN
         CALL SLNQ(NEQ,AA,DELTA,SINGULAR)
         IF(.NOT.SINGULAR) CALL PRINT
      END IF
      GO TO 200
C
C             END OF EXECUTION OF PROGRAM
C
 1000 CONTINUE
      RETURN
      END
      SUBROUTINE NEXT
      INCLUDE 'balninpt.cb'
      INTEGER I, J
C
C             NOW(I) CONTAINS THE CURRENT MINERAL CHOICES
C             IN ARRAY POSITIONS 1 THROUGH NEQ
C
      QUIT=.FALSE.
C
C             FIRST SET OF MINERALS IS CHOSEN
C
      IF(FIRST) THEN
         DO 10 I=1,NEQ
         MINPOS(I)=I
         MAXPOS(I)=NMINS-NEQ+I
         IF (FORCE(I).EQ.'F') MAXPOS(I)=MINPOS(I)
         NOW(I)=I
   10    CONTINUE
         IF(IMIX.EQ.1) THEN
            MAXPOS(1)=1
            MAXPOS(2)=2
         END IF
         FIRST=.FALSE.
C      WRITE(6,35) (MINPOS(L),L=1,NEQ)
C!      WRITE(6,35) (NOW(L),L=1,NEQ)
C      WRITE(6,35) (MAXPOS(L),L=1,NEQ)
         RETURN
      END IF
C
C             SET OF MINERALS (OTHER THAN FIRST TIME)
C             IS CHOSEN
      DO 20 I=NEQ,1,-1
      IF(NOW(I).LT.MAXPOS(I)) THEN
         NOW(I)=NOW(I)+1
         IF(I.LT.NEQ) THEN
            K=NOW(I)
            DO 30 J=I+1,NEQ
            K=K+1
            NOW(J)=K
   30       CONTINUE
         END IF
C      WRITE(6,35) (MINPOS(L),L=1,NEQ)
C!      WRITE(6,35) (NOW(L),L=1,NEQ)
C      WRITE(6,35) (MAXPOS(L),L=1,NEQ)
c  35 FORMAT(/' MINERALS FOR MODEL: ',20I4/)
         RETURN
      END IF
   20 CONTINUE
      QUIT=.TRUE.
      RETURN
      END
      SUBROUTINE INIT
      INCLUDE 'balninpt.cb'
      INTEGER I, L
C
C             SET PHASES 1 AND 2 IN MIXING CASE
C
      IF(IMIX.EQ.1) THEN
         PNAME(1)='INIT 1'
         PNAME(2)='INIT 2'
         ENAME(NEQ)='MIX'
         EDELTA(NEQ)=1.0D0
         PELT(1,16)='MIX'
         PCOEF(1,16)=1.0D0
         PELT(2,16)='MIX'
         PCOEF(2,16)=1.0D0
         DO 20 I=1,NELTS
         PELT(1,I)=ENAME(I)
         PCOEF(1,I)=SINIT1(I)
         PELT(2,I)=ENAME(I)
         PCOEF(2,I)=SINIT2(I)
   20    CONTINUE
      END IF
C
C             CALCALUTE ROW NUMBERS OF ELEMENTS
C
      DO 30 I=1,NMINS
      DO 50 L=1,16
      LELT(I,L)=0
      DO 40 K=1,NEQ
      IF(PELT(I,L).EQ.ENAME(K)) LELT(I,L)=K
   40 CONTINUE
   50 CONTINUE
   30 CONTINUE
      IF(IMIX.EQ.1) THEN
         TRANSFER(1)='+'
         TRANSFER(2)='+'
         FORCE(1)='F'
         FORCE(2)='F'
      END IF
      DO 60 I=1,NMINS
      IF(TRANSFER(I).EQ.'+'.OR.
     1   TRANSFER(I).EQ.'D'.OR.
     1   TRANSFER(I).EQ.'d') THEN
         TRANSFER(I)='+'
      ELSE IF(TRANSFER(I).EQ.'-'.OR.
     1   TRANSFER(I).EQ.'P'.OR.
     1   TRANSFER(I).EQ.'p') THEN
         TRANSFER(I)='-'
      ELSE IF(TRANSFER(I).EQ.' ') THEN
         TRANSFER(I)=' '
      ELSE
C!         WRITE(6,70) PNAME(I)
c  70    FORMAT(' ERROR IN MASS TRANSFER FLAG FOR ', A8)
      END IF
   60 CONTINUE
      RETURN
      END
      SUBROUTINE SET
      INCLUDE 'balninpt.cb'
      INTEGER I, J
C
C        INITIALIZE THE AA ARRAY
C
      DO 15 I=1,40
        DO 10 J=1,40
          AA(I,J)=0.0D0
   10   CONTINUE
   15 CONTINUE
C
C             PUT COEFFICIENTS IN THE A ARRAY
C
      DO 20 I=1,NEQ
        K=NOW(I)
        AA(I,NEQ+1)=EDELTA(I)
        DO 30 J=1,16
          IF(LELT(K,J).GT.0) AA(LELT(K,J),I)=PCOEF(K,J)
   30   CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE ROWCOL
      INCLUDE 'balninpt.cb'
      INTEGER IROW(40), ICOL(40), I, J
      INTRINSIC DABS
C
      ARRAYOK=.TRUE.
      DO 5 I=1,NEQ
        IROW(I)=0
        ICOL(I)=0
    5 CONTINUE
      DO 10 I=1,NEQ
        DO 20 J=1,NEQ
          IF(DABS(AA(I,J)).GT.1.0D-10) IROW(I)=1
          IF(DABS(AA(J,I)).GT.1.0D-10) ICOL(I)=1
   20   CONTINUE
        IF(IROW(I).EQ.0) THEN
C!         WRITE(6,30) ENAME(I)
c  30      FORMAT(1X,A8,'NOT CONTAINED IN ANY PHASE.')
          ARRAYOK=.FALSE.
        END IF
        IF(ICOL(I).EQ.0) THEN
C!         WRITE(6,40) PNAME(NOW(I))
c  40      FORMAT(1X,A8,' CONTAINS NO ELEMENTS.')
          ARRAYOK=.FALSE.
        END IF
   10 CONTINUE
      RETURN
      END
      SUBROUTINE PRINT
      INCLUDE 'balninpt.cb'
      CHARACTER*8 TEST
      INTEGER I
      LOGICAL MODELOK
C
C!      WRITE(6,5)
c   5 FORMAT(' NO.  PHASE    +/-      DELTA    CONSTRAINT')
      MODELOK=.TRUE.
      TEST='TRUE'
      DO 10 I=1,NEQ
      K=NOW(I)
      IF(TRANSFER(K).EQ.'-') THEN
         IF(DELTA(I).GT.0.0D0) TEST='FALSE'
      ELSE IF(TRANSFER(K).EQ.'+') THEN
         IF(DELTA(I).LT.0.0D0) TEST='FALSE'
      END IF
      IF(TEST.EQ.'FALSE') MODELOK=.FALSE.
C!      WRITE(6,20) K,PNAME(K),TRANSFER(K),DELTA(I),TEST
c  20 FORMAT(1X,I2,3X,A8,2X,A1,2X,F12.4,5X,A5)
   10 CONTINUE
c     IF(.NOT.MODELOK) THEN
C!         WRITE(6,30)
c  30    FORMAT(/' AT LEAST ONE OF THE MASS TRANSFER CONSTRAINTS',
c    1   ' WAS VIOLATED.')
c     ELSE
      IF(MODELOK) THEN
         IF(.NOT.SINGULAR) THEN
            MODGOOD=MODGOOD+1
            DO 40 I=1,NEQ
            K=NOW(I)
            WRITE(IUNIT,25) PNAME(K),TRANSFER(K),FORCE(K),DELTA(I)
   25 FORMAT(1X,A8,2X,A1,1X,A1,2X,F12.4,5X,A5)
   40       CONTINUE
            WRITE(IUNIT,50)
   50       FORMAT(1X)
         END IF
      END IF
      RETURN
      END
      SUBROUTINE SLNQ(N,A,X,SINGULAR)
      DOUBLE PRECISION A(40,40), X(40), D, B, CC
      INTEGER N, IOPT(10), J, NP1, NM1, II, JJ, I, M, K, L
      LOGICAL SINGULAR
      INTRINSIC DABS
C
C     SOLUTION OF N LINEAR EQUATIONS IN N UNKNOWNS BY GAUSSIAN
C     ELIMINATION OR DETERMINANT EVALUTAION.
C     A CONTAINS THE MATRIX OF THE COEFFICIENTS AND N INDICATES THE
C     ORDER OF THE MATRIX. IF J EQUALS ZERO, D CONTAINS THE VALUE OF THE
C     DETERMINANT. IF J DOES NOT EQUAL ZERO, X CONTAINS THE N VALUES OF
C     THE UNKNOWNS.
C
      SINGULAR=.FALSE.
      IOPT(9)=0
      J=1
      D=0.0D0
      NP1=N+1
      NM1=N-1
      IF(IOPT(9).NE.1) GO TO 120
      DO 110 II=1,N
      WRITE(6,210) (A(II,JJ),JJ=1,NP1)
  110 CONTINUE
  120 CONTINUE
      IF(N.EQ.1) GO TO 300
      DO 130 I=1,NM1
      M=I
      K=I+1
      B=A(I,I)
      DO 30 L=K,N
      IF(DABS(B)-DABS(A(L,I))) 20,30,30
   20 M=L
      B=A(L,I)
   30 CONTINUE
      IF (B) 40,170,40
   40 CC=A(M,I)
      IF (I-M) 50,70,50
   50 D=-D
      DO 60 L=I,NP1
      B=A(I,L)
      IF(DABS(CC).LT.1.0D-30) GO TO 180
      A(I,L)=A(M,L)/CC
   60 A(M,L)=B
      GO TO 90
   70 DO 80 L=I,NP1
      IF(DABS(CC).LT.1.0D-30) GO TO 180
      A(I,L)=A(I,L)/CC
   80 CONTINUE
   90 D=D*CC
      DO 100 M=K,N
      B=A(M,I)
      DO 100 L=I,NP1
  100 A(M,L)=A(M,L)-B*A(I,L)
  130 CONTINUE
      D=D*A(N,N)
      IF (J) 140,200,140
  140 CONTINUE
      IF(DABS(A(N,N)).LT.1.0D-30) GO TO 180
      X(N)=A(N,NP1)/A(N,N)
      K=NM1
  150 M=K+1
      B=0.0D0
      DO 160 L=M,N
  160 B=B+A(K,L)*X(L)
      X(K)=A(K,NP1)-B
      K=K-1
      IF (K) 170,200,150
  170 IF (J) 180,190,180
  180 CONTINUE
      IF(IOPT(9).EQ.1) WRITE(6,230)
      SINGULAR=.TRUE.
      RETURN
  190 D=0.0D0
  200 CONTINUE
      IF(IOPT(9).NE.1) GO TO 320
      WRITE(6,330)
  330 FORMAT(1X,'DELTA VALUES')
      WRITE(6,340) (X(I),I=1,N)
  340 FORMAT(5X,1P8D10.1)
  320 CONTINUE
      RETURN
  300 CONTINUE
      IF(DABS(A(1,1)).LT.1.0D-30) GO TO 180
      X(1)=A(1,2)/A(1,1)
      GO TO 190
C
C
C
  210 FORMAT(/(5X,1P10D12.3))
  230 FORMAT (' MINERAL COMPOSITIONS ARE  NOT LINEARLY INDEPENDENT.')
      END
      SUBROUTINE OPENIT(QUERY, FNAME, IUNIT, STAT, BATCH, ISCR)
C
C     Opens file on specified unit after soliciting file name.
C
      CHARACTER*(*) QUERY, FNAME, STAT
      INTEGER IUNIT, ISCR
      LOGICAL BATCH
C
C     QUERY - STRING TO PRINT FOR SOLICITING FILE NAME
C     FNAME - INPUT DEFAULT NAME, OUTPUT NAME OF FILE OPENED
C     IUNIT - UNIT NUMBER TO OPEN
C     STAT  - STATUS OF FILE TO OPEN
C     BATCH - .TRUE. IF READING FROM INIT
C             .FALSE. IF QUERYING INTERACTIVIELY
C
C     ISCR  - UNIT NUMBER FOR FILE CONTAINING FILE NAMES
C
      CHARACTER*80 FNAMET
      LOGICAL FOUND
      INTEGER N, LENCHR
      EXTERNAL LENCHR
C
C                           BATCH READING OF FILE NAME
C
      IF (BATCH) THEN
         READ(ISCR, 100, END=10) FNAME
         GOTO 20
      ENDIF
C
C                           ERROR IN FILE NAME
C
 10   CONTINUE
      BATCH = .FALSE.
C
C                           INTERACTIVE SOLICITING OF FILE NAME
C
 20   CONTINUE
      IF (.NOT.BATCH) THEN
         WRITE(*,110) QUERY(:LENCHR(QUERY))
         N = LENCHR(FNAME)
         IF (N.NE.0) WRITE(*,115) FNAME(:N)
         READ(*,100) FNAMET
         IF (LENCHR(FNAMET).NE.0) FNAME = FNAMET
      END IF
      N = LENCHR(FNAME)
C
C                           CHECK STAT='OLD' EXIST
C
      IF (STAT.EQ.'OLD') THEN
         INQUIRE (FILE=FNAME(:N), EXIST=FOUND)
         IF (.NOT.FOUND) THEN
            WRITE(*,120) FNAME(:N)
            WRITE(*,140)
            GOTO 10
         ENDIF
      ENDIF
C
C                           CHECK STAT='NEW' EXIST
C
 25   CONTINUE
      IF (STAT.EQ.'NEW') THEN
         INQUIRE (FILE=FNAME(:N), EXIST=FOUND)
         IF (FOUND) THEN
            WRITE (*,150) FNAME(:N)
            READ (*,100) FNAMET
            IF (FNAMET.NE.' ') THEN
               FNAME=FNAMET
               N = LENCHR(FNAME)
               GOTO 25
            ELSE
               STAT='OLD'
            ENDIF
         ENDIF
      END IF
C
C                           OPEN FILE
C
      OPEN(UNIT=IUNIT, FILE=FNAME(:N), STATUS=STAT, ERR=30)
      GOTO 40
C
C                           ERROR OPENING FILE
C
 30   CONTINUE
      WRITE(*,130) FNAME(:N)
      GOTO 10
C
C                          RETURN
C
 40   CONTINUE
      IF (.NOT.BATCH) WRITE(*,140)
      RETURN
 100  FORMAT (A)
 110  FORMAT (1X, A)
 115  FORMAT (' Default: ', A)
 120  FORMAT (' Error: file not found: ', /, 1X, A)
 130  FORMAT (' Error: error opening file: ', /, 1X, A)
 140  FORMAT (1X)
 150  FORMAT (/, ' File exists: ', A, /,
     &        ' Type new filename or <Enter> to overwrite.')
      END
C
C
      INTEGER FUNCTION LENCHR(STRING)
C
C     Determine length of character string minus trailing blanks
C
      CHARACTER*(*) STRING
      INTEGER MAX, I
      INTRINSIC LEN
C
      MAX = LEN(STRING)
      DO 100 I = MAX, 1, -1
        IF (STRING(I:I).NE.' ') THEN
          LENCHR = I
          GOTO 200
        ENDIF
 100  CONTINUE
      LENCHR = 0
C
 200  CONTINUE
      RETURN
      END
